(* 002 affiche_en_couleur *)
(* 02 aou 94 *)

(*$r+ *)
program affiche_en_couleur;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe affiche';
        k_titre_fenetre= 'affiche en couleurs';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  procedure affiche_chaine(p_poignee_contexte_peripherique: hDC;
      p_x, p_y: integer;
      p_chaine: string; p_taille: integer);
    var l_taille, l_indice: integer;
        l_justification_precedente: Word;
    begin
      l_taille:= length(p_chaine);
      if l_taille> p_taille
        then p_chaine[0]:= chr(p_taille)
        else
          for l_indice:= l_taille+ 1 to p_taille do
            p_chaine:= p_chaine+ ' ';

      l_justification_precedente:= SetTextAlign(p_poignee_contexte_peripherique, ta_Left or ta_Top);
      TextOut(p_poignee_contexte_peripherique, p_x, p_y, @p_chaine[1], p_taille);
      SetTextAlign(p_poignee_contexte_peripherique, l_justification_precedente);
    end; (* affiche_chaine *)

  procedure affiche_entier(p_poignee_contexte_peripherique: hDC;
      p_x, p_y: integer;
      p_entier: integer; p_taille: integer);
    var l_chaine: string;
        l_justification_precedente: Word;
        l_taille_caractere: Word;
    begin
      str(p_entier, l_chaine);

      l_taille_caractere:= LoWord(GetTextExtent(p_poignee_contexte_peripherique, '0', 1));

      l_justification_precedente:= SetTextAlign(p_poignee_contexte_peripherique, ta_Right);
      TextOut(p_poignee_contexte_peripherique, p_x+ l_taille_caractere* p_taille, p_y,
          @l_chaine[1], Length(l_chaine));
      SetTextAlign(p_poignee_contexte_peripherique, l_justification_precedente);
    end; (* affiche_entier *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_largeur_caractere: Word= 0;
          ls_hauteur_caractere: Word= 0;

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
      var l_poignee_contexte_ecran: hDC;
          l_metrique: tTextMetric;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
        GetTextMetrics(l_poignee_contexte_ecran, l_metrique);
        with l_metrique do
        begin
          ls_largeur_caractere:= tmAveCharWidth;
          ls_hauteur_caractere:= tmHeight;
        end; (* with l_metrique *)

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_create *)

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word;
          p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
      var l_poignee_contexte_ecran: hDC;
          l_ligne: Word;

      procedure affiche(p_rouge, p_vert, p_bleu, p_rouge_fond, p_vert_fond, p_bleu_fond: Byte;
          p_texte: String);
        begin
          SetTextColor(l_poignee_contexte_ecran, RGB(p_rouge, p_vert, p_bleu));
          SetBkColor(l_poignee_contexte_ecran, RGB(p_rouge_fond, p_vert_fond, p_bleu_fond));
          affiche_chaine(l_poignee_contexte_ecran, 0, l_ligne, p_texte, 20);

          SetTextColor(l_poignee_contexte_ecran, RGB(p_rouge_fond, p_vert_fond, p_bleu_fond));
          SetBkColor(l_poignee_contexte_ecran, RGB(p_rouge, p_vert, p_bleu));

          affiche_entier(l_poignee_contexte_ecran, 21* ls_largeur_caractere, l_ligne, p_rouge, 5);
          affiche_entier(l_poignee_contexte_ecran, 26* ls_largeur_caractere, l_ligne, p_vert, 5);
          affiche_entier(l_poignee_contexte_ecran, 31* ls_largeur_caractere, l_ligne, p_bleu, 5);

          inc(l_ligne, ls_hauteur_caractere);
        end; (* affiche *)

      begin (* traite_wm_l_button_down *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
        l_ligne:= 0;

        affiche(0, 0, 0,    255, 255, 255, 'noir / blanc');
        affiche(255, 0, 0,    0, 255, 0, 'rouge / vert');
        affiche(0, 0, 255,    0, 255, 255, 'bleu / bleu-vert');
        affiche(255, 0, 255,  255, 255, 0 ,'violet / jaune');

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create : traite_wm_create(Pointer(p_l_param));
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          (* -- la fentre par dfaut *)
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de recuperation et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
