(* 002 animpale *)
(* 09 sep 94 *)

(*$r+ *)
program illustre_anime_palette;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe anime palette';
        k_titre_fenetre= 'Anime Palette';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure affiche_contexte_y(p_poignee_contexte_ecran: hDC; p_y: Word;
          p_message: String);
        begin
          TextOut(p_poignee_contexte_ecran, 0, p_y, @p_message[1], length(p_message));
        end; (* affiche *)

      procedure affiche_palette_systeme;
        (* -- cre une palette logique et la colorie avec les couleurs de la palette systme *)
        var l_poignee_contexte_ecran: hDC;
            l_pt_info_palette_logique: ^tLogPalette;
            l_indice: Integer;

            l_poignee_palette, l_poignee_palette_precedente: hPalette;
            l_poignee_brosse_indice, l_poignee_brosse_couleur: hBrush;
            l_rectangle: tRect;
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          affiche_contexte_y(l_poignee_contexte_ecran, 0, 'palette systme');

          (* -- alloue la place pour les informations de la palette logique *)
          GetMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

          (* -- remplis les informations de la palette logique *)
          with l_pt_info_palette_logique^ do
          begin
            palVersion:= $300;
            palNumEntries:= 256;
            for l_indice:= 0 to 255 do
              (*$r-*)
              with palPalEntry[l_indice] do
              (*$r+*)
              begin
                (* -- indique que la valeur peRed est un indice dans la palette systme *)
                peFlags:= pc_Explicit;
                peRed:= l_indice;
                (* -- inutilis *)
                peGreen:= 0; peBlue:= 0;
              end;
          end;

          (* -- cre la palette logique *)
          l_poignee_palette:= CreatePalette(l_pt_info_palette_logique^);

          (* -- place la palette logique dans le contexte *)
          l_poignee_palette_precedente:=
              SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
          (* -- ajuste la palette systme en utilisant la palette du contexte *)
          RealizePalette(l_poignee_contexte_ecran);

          (* -- affiche le rsultat *)
          for l_indice:= 0 to 255 do
          begin
            (* -- couleur via PaletteIndex(indice) *)
            l_poignee_brosse_indice:= CreateSolidBrush(PaletteIndex(l_indice));
            SetRect(l_rectangle, l_indice* 3, 25, (l_indice+ 1)* 3, 25+ 12);
            FillRect(l_poignee_contexte_ecran, l_rectangle, l_poignee_brosse_indice);
            DeleteObject(l_poignee_brosse_indice);

            (* -- couleur via $01bbvvrr *)
            if (l_indice>= 10) and (l_indice< 246)
              then begin
                  l_poignee_brosse_couleur:= CreateSolidBrush($01000000+ l_indice);
                  SetRect(l_rectangle, l_indice* 3, 25+ 13, (l_indice+ 1)* 3, 50);
                  FillRect(l_poignee_contexte_ecran, l_rectangle, l_poignee_brosse_couleur);
                  DeleteObject(l_poignee_brosse_couleur);
                end;
          end; (* for *)

          (* -- dslectionne avant de dtruire *)
          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, False);
          (* -- supprime notre palette *)
          DeleteObject(l_poignee_palette);

          (* -- rend la mmoire des informations de palette *)
          FreeMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* affiche_palette_systeme *)

      procedure anime_palette;
        (* -- anime une plage de couleurs *)
        const k_indice_debut_animation= 60;
              k_indice_fin_animation= 120;
        var l_pt_palette_logique: ^tLogPalette;

        procedure cree_palette_avec_reservation;

          function f_gamma(p_indice: Word): Word;
            (* -- correction gamma: remonte les teintes sombres *)
            begin
              if p_indice= 0
                then f_gamma:= 0
                else f_gamma:= round(255* exp(1/2.222* ln(p_indice/ 117)));
            end; (* f_gamma *)

          var l_indice: Integer;

          begin
            GetMem(l_pt_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

            with l_pt_palette_logique^ do
            begin
              palVersion:= $0300;
              palNumEntries:= 236;
              for l_indice:= 0 to 235 do
                (*$r-*)
                with palPalEntry[l_indice] do
                (*$r+*)
                begin
                  peGreen:= 0;
                  if l_indice= (k_indice_debut_animation+ k_indice_fin_animation) div 2
                    then begin
                        peRed:= 255; peBlue:= 255; peGreen:= 255;
                      end
                    else
                      if l_indice< 118
                        then begin
                            peRed:= f_gamma(l_indice);
                            peBlue:= 0;
                          end
                        else begin
                            peBlue:= f_gamma(235- l_indice);
                            peRed:= 0;
                          end;
                  (* -- rserve les entres qui vont tre animes *)
                  if (l_indice>= k_indice_debut_animation) and (l_indice<= k_indice_fin_animation)
                    then peFlags:= pc_Reserved
                    else peFlags:= 0;
                end;
            end;
          end; (* cree_palette_avec_reservation *)

        procedure affiche_palette(p_poignee_contexte_ecran: hDC; p_y: Word;
            p_message: String);
          var l_indice: Word;
              l_poignee_brosse: hBrush;
              l_rectangle: tRect;
          begin
            affiche_contexte_y(p_poignee_contexte_ecran, p_y, p_message);

            (* -- affiche la palette normale *)
            for l_indice:= 0 to 235 do
            begin
              l_poignee_brosse:= CreateSolidBrush($01000000+ l_indice);
              SetRect(l_rectangle, l_indice* 3, p_y+ 25, (l_indice+ 1)* 3, p_y+ 50);
              FillRect(p_poignee_contexte_ecran, l_rectangle, l_poignee_brosse);
              DeleteObject(l_poignee_brosse);
            end; (* for *)
          end; (* affiche_palette *)

        procedure anime_la_palette(p_poignee_contexte_ecran: hDC; p_poignee_palette: hPalette);
          var l_couleurs_animation: Array[k_indice_debut_animation..k_indice_fin_animation]
                 of tPaletteEntry;
              l_indice: Integer;

          procedure decale_palette_animation;
            var l_sauve_entree: tPaletteEntry;
                l_rotation: Word;
            begin
              (* -- l'entre du dbut *)
              l_sauve_entree:= l_couleurs_animation[k_indice_debut_animation];

              (*  -- dcale tout d'un cran  gauche *)
              for l_rotation:= k_indice_debut_animation to k_indice_fin_animation- 1 do
                l_couleurs_animation[l_rotation]:= l_couleurs_animation[l_rotation+ 1];

              (* -- met l'entre finale *)
              l_couleurs_animation[k_indice_fin_animation]:= l_sauve_entree;
            end; (* decale_palette_animation *)

          var l_repetition: Word;

          begin (* anime_la_palette *)
            (* -- cre la premire palette d'animation, par exemple par copie *)
            for l_indice:= k_indice_debut_animation to k_indice_fin_animation do
              (*$r-*)
              l_couleurs_animation[l_indice]:= l_pt_palette_logique^.palPalEntry[l_indice];
              (*$r+*)

            for l_repetition:= 0 to k_indice_fin_animation- k_indice_debut_animation do
            begin
              (* -- rotation des couleurs de notre table *)
              decale_palette_animation;
              (* -- copie notre table dans la palette *)
              AnimatePalette(p_poignee_palette,
                  k_indice_debut_animation, k_indice_fin_animation+ 1- k_indice_debut_animation,
                  l_couleurs_animation);
              (* -- copie notre palette dans la palette systme *)
              RealizePalette(p_poignee_contexte_ecran);
              (* -- le rsultat *)
              affiche_palette(p_poignee_contexte_ecran, 55, 'anime');
            end;
          end; (* anime_la_palette *)

        var l_poignee_contexte_ecran: hDC;
            l_poignee_palette, l_poignee_palette_precedente: hPalette;

        begin (* anime_palette *)
          cree_palette_avec_reservation;

          l_poignee_palette:= CreatePalette(l_pt_palette_logique^);

          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          l_poignee_palette_precedente:=
              SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
          RealizePalette(l_poignee_contexte_ecran);

          anime_la_palette(l_poignee_contexte_ecran, l_poignee_palette);

          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, True);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);

          DeleteObject(l_poignee_palette);
          FreeMem(l_pt_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));
        end; (* anime_palette *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'S' : affiche_palette_systeme;

          'A' : anime_palette;
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);

        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(LtGray_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- paramtre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
