(* 002 bitmind2 *)
(* 07 sep 94 *)

(*$r+ *)
program bitmap_cree_par_CreateBitmapIndirect;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe bitmap';
        k_titre_fenetre= 'affiche bitmap';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_entier_chaine(p_entier: Integer): string;
    var l_chaine: string;
    begin
      str(p_entier, l_chaine);
      f_entier_chaine:= l_chaine;
    end; (* f_entier_chaine *)

{
  const (* -- noir et blanc. Motif $33 *)
        k_largeur= 128; k_hauteur= 16; k_plans= 1; k_bits_par_pixel= 1;
  const (* -- rien: *)
        k_largeur= 256; k_hauteur= 16; k_plans= 1; k_bits_par_pixel= 4;
        k_largeur= 256; k_hauteur= 16; k_plans= 8; k_bits_par_pixel= 1;
}
  const (* -- 256 couleurs. Couleurs 1..255 *)
        k_largeur= 256; k_hauteur= 16; k_plans= 1; k_bits_par_pixel= 8;
  type t_plan= array[0..k_hauteur- 1, 0.. 2* ((k_largeur * k_bits_par_pixel+ 15) div 16)- 1] of Byte;
  var g_table_bits: array[1..k_plans] of t_plan;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_paint;

      var l_structure_dessin: tPaintStruct;
          l_poignee_contexte_ecran: hDC;

      procedure affiche_xy(p_x, p_y: Word; p_titre: String);
        begin
          TextOut(l_poignee_contexte_ecran, p_x, p_y, @p_titre[1], Length(p_titre));
        end; (* affiche *)

      procedure affiche_info_bitmap(p_y, p_x: Integer; p_info_bitmap: tBitmap);
        var l_poignee_bitmap: hBitmap;
            l_y: Integer;

        procedure affiche(p_titre: String; p_valeur: Integer);
          begin
            p_titre:= p_titre+ f_entier_chaine(p_valeur);
            TextOut(l_poignee_contexte_ecran, p_x, l_y, @p_titre[1], Length(p_titre));
            inc(l_y, 20);
          end; (* affiche *)

        begin (* affiche_info_bitmap *)
          l_y:= p_y; SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
          with p_info_bitmap do
          begin
            affiche('bmHeight     ', bmHeight);
            affiche('bmWidth      ', bmWidth);
            affiche('bmPlanes     ', bmPlanes);
            affiche('bmBitsPixel  ', bmBitsPixel);
            affiche('bmWidthBytes ', bmWidthBytes);
          end;
        end; (* affiche_info_bitmap *)

      procedure affiche_info_poignee_bitmap(p_y, p_x: Integer; p_poignee_bitmap: hBitmap);
        var l_info_bitmap: tBitmap;
        begin
          GetObject(p_poignee_bitmap, SizeOf(tBitmap), @l_info_bitmap);
          affiche_info_bitmap(p_y, p_x, l_info_bitmap);
        end; (* affiche_info_poignee_bitmap *)

      procedure affiche_info_bitmap_ecran;
        var l_poignee_bitmap: hBitMap;
        begin
          l_poignee_bitmap:= CreateCompatibleBitmap(l_poignee_contexte_ecran, 10, 10);
          affiche_xy(0, 0, 'Contexte cran:');
          affiche_info_poignee_bitmap(20, 10, l_poignee_bitmap);
          DeleteObject(l_poignee_bitmap);
        end; (* affiche_info_bitmap_ecran *)

      procedure affiche_bitmap;

        procedure cree_bits;
          var l_plan, l_largeur, l_hauteur: Word;
          begin
            Fillchar(g_table_bits, Sizeof(g_table_bits), 0);

            affiche_xy(420, 20, 'octets table bits: '+ f_entier_chaine(SizeOf(g_table_bits)));
            affiche_xy(420, 40, 'octets largeur '
                + f_entier_chaine(2* ((k_largeur * k_bits_par_pixel+ 15) div 16)));

            for l_plan:= 1 to k_plans do
              for l_hauteur:= 0 to k_hauteur- 1 do
                for l_largeur:= 0 to (2* k_largeur* k_bits_par_pixel+ 15) div 16 - 1 do
                begin
                  if (k_plans= 1) and (k_bits_par_pixel= 1)
                    then g_table_bits[l_plan, l_hauteur, l_largeur]:= $33
                    else
                      if (k_plans= 1) and (k_bits_par_pixel= 8)
                        then g_table_bits[l_plan, l_hauteur, l_largeur]:= l_largeur
                        else
                          if (k_plans= 1) and (k_bits_par_pixel= 4)
                            then begin
                                g_table_bits[l_plan, l_hauteur, l_largeur]:= l_largeur;
                                g_table_bits[l_plan, l_hauteur, l_largeur]:= $33;
                              end;
                end; (* for *)
          end; (* cree_bits *)

        var l_info_bitmap: tBitmap;
            l_poignee_bitmap, l_poignee_bitmap_precedente: hBitMap;
            l_octets_bitmap: Word;
            l_poignee_contexte_memoire: hDC;

        begin (* affiche_bitmap *)
          (* -- cre la table de bits *)
          cree_bits;

          (* -- rcupre une poigne d'une bitmap avec cette structure *)
          l_poignee_bitmap:= CreateBitmap(k_largeur, k_hauteur, k_plans, k_bits_par_pixel,
              @g_table_bits);

          affiche_xy(200, 0, 'Bitmap:');
          affiche_info_poignee_bitmap(20, 210, l_poignee_bitmap);

          (* -- cre un contexte mmoire pour manipuler la bitmap *)
          l_poignee_contexte_memoire:= CreateCompatibleDc(l_poignee_contexte_ecran);
          (* -- slectionne la bitmap dans le contexte mmoire *)
          l_poignee_bitmap_precedente:= SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap);

          (* -- copie la bitmap vers l'cran *)
          BitBlt(l_poignee_contexte_ecran, 420, 70, k_largeur, k_hauteur,
              l_poignee_contexte_memoire, 0, 0, SrcCopy);

          (* -- supprime la bitmap: commence par la dslectionner *)
          SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap_precedente);
          (* -- la supprime *)
          DeleteObject(l_poignee_bitmap);
          (* -- supprime le contexte mmoire *)
          DeleteDc(l_poignee_contexte_memoire);
        end; (* affiche_bitmap *)

      begin (* traite_mwPaint *)
        l_poignee_contexte_ecran:= BeginPaint(p_poignee_fenetre, l_structure_dessin);

        affiche_info_bitmap_ecran;
        affiche_bitmap;

        EndPaint(p_poignee_fenetre, l_structure_dessin);
      end; (* traite_wmPaint *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Paint: traite_wm_paint;
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(LtGray_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
