(* 002 bmp *)
(* 12 sep 94 *)

(*$r+ *)
program affiche_dib_cree_par_workshop;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;
  type t_long_word= record
                      lo, hi: word;
                    end;
  type t_adresse= record
                    offset, segment: Word;
                  end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe bmp';
        k_titre_fenetre= 'Sauve, Rouge-Vert-Jaune, Charge';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_gros_ptr(p_pt: Pointer; p_offset: LongInt): Pointer;
    begin
      f_gros_ptr:= Ptr(t_long_word(p_pt).hi+ t_long_word(p_offset).hi* SelectorInc,
        + t_long_word(p_pt).lo+ t_long_word(p_offset).lo);
    end; (* f_gros_ptr *)

  procedure affiche_palette_systeme(p_poignee_fenetre: hWnd; p_x, p_y, p_taille: Word);
        (* -- cre une palette logique et la colorie avec les couleurs de la palette systme *)
    var l_poignee_contexte_ecran: hDC;
        l_pt_info_palette_logique: ^tLogPalette;
        l_indice: Integer;

        l_poignee_palette, l_poignee_palette_precedente: hPalette;

        l_x, l_y: Word;
        l_poignee_brosse_indice: hBrush;
        l_rectangle: tRect;
    begin
      l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

      (* -- alloue la place pour les informations de la palette logique *)
      GetMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

      (* -- remplis les informations de la palette logique *)
      with l_pt_info_palette_logique^ do
      begin
        palVersion:= $300;
        palNumEntries:= 256;
        for l_indice:= 0 to 255 do
          (*$r-*)
          with palPalEntry[l_indice] do
          (*$r+*)
          begin
            (* -- indique que la valeur peRed est un indice dans la palette systme *)
            peFlags:= pc_Explicit;
            peRed:= l_indice;
            (* -- inutilis *)
            peGreen:= 0; peBlue:= 0;
          end;
      end;

      (* -- cr la palette logique *)
      l_poignee_palette:= CreatePalette(l_pt_info_palette_logique^);

      (* -- place la palette logique dans le contexte *)
      l_poignee_palette_precedente:=
          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
      (* -- ajuste la palette systme en utilisant la palette du contexte *)
      RealizePalette(l_poignee_contexte_ecran);

      (* -- affiche le rsultat *)
      for l_indice:= 0 to 255 do
      begin
        (* -- couleur via PaletteIndex(indice) *)
        l_poignee_brosse_indice:= CreateSolidBrush(PaletteIndex(l_indice));
        l_x:= p_x+ (l_indice mod 16)* p_taille;
        l_y:= p_y+ (l_indice div 16)* p_taille;
        SetRect(l_rectangle, l_x, l_y, l_x+ p_taille, l_y+ p_taille);
        FillRect(l_poignee_contexte_ecran, l_rectangle, l_poignee_brosse_indice);
        DeleteObject(l_poignee_brosse_indice);
      end; (* for *)

      (* -- dslectionne avant de dtruire *)
      SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, False);
      (* -- supprime notre palette *)
      DeleteObject(l_poignee_palette);

      (* -- rend la mmoire des informations de palette *)
      FreeMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

      ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
    end; (* affiche_palette_systeme *)

  procedure cree_bmp(p_poignee_contexte: hDC;
      p_x, p_y: Integer; p_largeur, p_hauteur: Word;
      p_nom: String);

    procedure copie_ecran_dans_bitmap(p_x, p_y, p_largeur, p_hauteur: Integer;
        var pv_poignee_bitmap_ancienne: hBitmap);
      var l_poignee_contexte_memoire: tHandle;
          l_poignee_bitmap_precedente: hBitmap;
      begin
        (* -- dfinis l'organisation couleur *)
        l_poignee_contexte_memoire:= CreateCompatibleDC(p_poignee_contexte);
        (* -- alloue *)
        pv_poignee_bitmap_ancienne:= CreateCompatibleBitmap(p_poignee_contexte,
            p_largeur, p_hauteur);

        (* -- place dans le contexte *)
        l_poignee_bitmap_precedente:= SelectObject(l_poignee_contexte_memoire,
            pv_poignee_bitmap_ancienne);

        (* -- copie les bits de l'cran dans la bitmap mmoire *)
        BitBlt(l_poignee_contexte_memoire, 0, 0, p_largeur, p_hauteur,
            p_poignee_contexte, p_x, p_y, SrcCopy);

        (* -- sort la bitmap pour pouvoir librer le contexte mmoire *)
        pv_poignee_bitmap_ancienne:= SelectObject(l_poignee_contexte_memoire,
            l_poignee_bitmap_precedente);

        DeleteDc(l_poignee_contexte_memoire);
      end; (* copie_ecran_dans_bitmap *)

    var l_taille_palette: Word;

    procedure transforme_bitmap_en_dib(p_poignee_bitmap_ancienne: hBitmap;
        var pv_poignee_dib: tHandle);
      var l_pt_info_bitmap_dib: pBitmapInfo;

      procedure alloue_et_remplis_en_tete_dib;
        var l_bitmap_ancien_format: tBitmap;
            l_en_tete_bitmap_dib_temporaire: tBitmapInfoHeader;
            l_nombre_couleurs: Word;
        begin
          (* -- cre l'en-tte DIB. Valeurs par dfaut *)
          Fillchar(l_en_tete_bitmap_dib_temporaire, Sizeof(tBitmapInfoHeader), 0);

          (* -- rcupre les tailles et couleurs de la bitmap cran *)
          GetObject(p_poignee_bitmap_ancienne, Sizeof(l_bitmap_ancien_format),
              @l_bitmap_ancien_format);

          (* -- remplis les zones info pour la bitmap dib *)
          with l_bitmap_ancien_format, l_en_tete_bitmap_dib_temporaire do
          begin
            biSize:= SizeOf(tBitmapInfoHeader);
            (* -- pixels de large *)
            biWidth:= ((bmWidth+ 31) div 32)* 32;
            biHeight:= bmHeight;

            biPlanes:= 1;
            (* -- bit par pixel *)
            biBitCount:= bmBitsPixel* bmPlanes;

            (* -- octets:= (pixels-en-largeur * bits-par-pixel / 8-bit-par-octet) * hauteur *)
            biSizeImage:= bmWidth div 8;
            biSizeImage:= biSizeImage* biBitCount* bmHeight;

            l_nombre_couleurs:= 1 shl biBitCount;
            l_taille_palette:= 4* l_nombre_couleurs;

            (* -- alloue *)
            pv_poignee_dib:= GlobalAlloc(GMem_Moveable or GMem_ZeroInit,
                SizeOf(tBitmapInfoHeader)+ l_taille_palette+ biSizeImage);
          end; (* with *)

          (* -- rcupre un pointeur *)
          l_pt_info_bitmap_dib:= GlobalLock(pv_poignee_dib);

          (* -- copie dj l'en-tte *)
          move(l_en_tete_bitmap_dib_temporaire, l_pt_info_bitmap_dib^, 40);
        end; (* alloue_et_remplis_en_tete_dib *)

      procedure remplis_table_bits;
        var l_pt_bits: Pointer;
            (* -- permet de calculer offset l_pt_bits *)
            l_ajuste_pt_bits: t_adresse absolute l_pt_bits;
            l_poignee_contexte_memoire: tHandle;
        begin
          (* -- calcule le pointeur vers les bits *)
          l_pt_bits:= l_pt_info_bitmap_dib;
          l_ajuste_pt_bits.offset:= l_ajuste_pt_bits.offset+
              SizeOf(tBitmapInfoHeader)+ l_taille_palette;

          (* -- transfre la table des couleurs du contexte dans la DIB *)
          (* --    et les bits de bitmap ancienne vers DIB *)
          GetDIBits(p_poignee_contexte,
               p_poignee_bitmap_ancienne,
               0, l_pt_info_bitmap_dib^.bmiHeader.biHeight,
               l_pt_bits,
               l_pt_info_bitmap_dib^,
               dib_RGB_Colors);
          GlobalUnlock(pv_poignee_dib);

          ReleaseDc(0, l_poignee_contexte_memoire);
        end; (* remplis_table_bits *)

      begin (* transforme_bitmap_en_dib *)
        alloue_et_remplis_en_tete_dib;
        remplis_table_bits;

        DeleteObject(p_poignee_bitmap_ancienne);
      end; (* transforme_en_dib *)

    procedure copie_dans_fichier(p_poignee_dib: tHandle);
      var l_en_tete_fichier_bmp: tbitmapFileHeader;
          l_pt_info_bitmap_dib: pBitmapInfo;
          l_fichier: File;
          l_taille, l_offset, l_quantite: LongInt;
      begin
        l_pt_info_bitmap_dib:= GlobalLock(p_poignee_dib);

        with l_en_tete_fichier_bmp, l_pt_info_bitmap_dib^, bmiHeader do
        begin
          bfType:= Ord('M')* 256+ ord('B');
          bfSize:= SizeOf(l_en_tete_fichier_bmp)+
              SizeOf(tBitmapInfoHeader)+ l_taille_palette+ biSizeImage;
          bfReserved1:= 0;
          bfReserved2:= 0;
          bfOffBits:= SizeOf(l_en_tete_fichier_bmp)+
              SizeOf(tBitmapInfoHeader)+ l_taille_palette;

          assign(l_fichier, p_nom);
          rewrite(l_fichier, 1);

          (* -- l'en-tte disque d'un .BMP *)
          BlockWrite(l_fichier, l_en_tete_fichier_bmp, SizeOf(l_en_tete_fichier_bmp));

          (* -- la bitmap DIB *)
          l_taille:= SizeOf(tBitmapInfoHeader)+ l_taille_palette+ biSizeImage;
          l_offset:= 0;
          while l_offset< l_taille do
          begin
            l_quantite:= l_taille- l_offset;
            if l_quantite> 32768
              then l_quantite:= 32768;

            BlockWrite(l_fichier, f_gros_ptr(l_pt_info_bitmap_dib, l_offset)^, l_quantite);

            l_offset:= l_offset+ l_quantite;
          end;

          close(l_fichier);
        end; (* with *)
      end; (* copie_dans_fichier *)

    var l_poignee_bitmap_ancienne: hBitmap;
        l_poignee_bitmap_dib: tHandle;

    begin (* cree_bmp *)
      copie_ecran_dans_bitmap(p_x, p_y, p_largeur, p_hauteur,
        l_poignee_bitmap_ancienne);
      transforme_bitmap_en_dib(l_poignee_bitmap_ancienne, l_poignee_bitmap_dib);
      copie_dans_fichier(l_poignee_bitmap_dib);

      GlobalFree(l_poignee_bitmap_dib);
    end; (* cree_bmp *)

  procedure charge_et_affiche_bmp(p_poignee_fenetre: hWnd; p_x, p_y: Word; p_nom: String);
    var l_pt_info_bitmap_dib: pBitmapInfo;
        l_poignee_bits: tHandle;
        l_pt_bits: Pointer;
        l_taille_en_tete_et_palette: Word;

    procedure charge_en_memoire;
      var l_fichier: File;
          l_bits_par_pixel: Word;
          l_octets_table_bits: LongInt;
          l_offset, l_quantite: LongInt;
      begin
        assign(l_fichier, p_nom);
        reset(l_fichier, 1);

        (* -- cherche bits / pixel *)
        Seek(l_fichier, $1C);
        BlockRead(l_fichier, l_bits_par_pixel, 2);
        (* -- calcule la taille mmoire en-tte + palette *)
        l_taille_en_tete_et_palette:= SizeOf(tBitmapInfoHeader)+ (1 shl l_bits_par_pixel)* 4;

        GetMem(l_pt_info_bitmap_dib, l_taille_en_tete_et_palette);

        (* -- lit l'en-tte *)
        Seek(l_fichier, SizeOf(tBitmapFileHeader));
        BlockRead(l_fichier, l_pt_info_bitmap_dib^, l_taille_en_tete_et_palette);

        with l_pt_info_bitmap_dib^, bmiHeader do
        begin
          l_octets_table_bits:= biSizeImage;

          (* -- alloue la place pour les bits *)
          l_poignee_bits:= GlobalAlloc(gmem_Moveable Or gmem_ZeroInit, l_octets_table_bits);
          l_pt_bits:= GlobalLock(l_poignee_bits);

          (* -- charge les bits *)
          l_offset:= 0;
          while l_offset< l_octets_table_bits do
          begin
            l_quantite:= l_octets_table_bits- l_offset;
            if l_quantite> 32768
              then l_quantite:= 32768;

            BlockRead(l_fichier, f_gros_ptr(l_pt_bits, l_offset)^, l_quantite);
            l_offset:= l_offset+ l_quantite;
          end; (* while *)
        end; (* with l_pt_info_bitmap_dib *)

        close(l_fichier);
      end; (* charge_en_memoire *)

    var l_poignee_bitmap_dib: hBitmap;

    procedure cree_dib;
      var l_poignee_dc: hDC;
      begin
        (* -- cre la bitmap *)
        l_poignee_dc:= CreateDC('DISPLAY', nil, nil, nil);
        with l_pt_info_bitmap_dib^ do
          l_poignee_bitmap_dib:= CreateDIBitmap(l_poignee_dc, bmiHeader, cbm_Init,
              l_pt_bits, l_pt_info_bitmap_dib^, 0);
        DeleteDC(l_poignee_dc);
      end; (* cree_dib *)

    procedure cree_palette(var pv_poignee_palette: hPalette);
      var l_pt_palette_logique: ^tLogPalette;
          l_nombre_couleurs: Word;
          l_indice: Word;
      begin
        with l_pt_info_bitmap_dib^, bmiHeader do
        begin
          l_nombre_couleurs:= 1 shl biBitCount;

          GetMem(l_pt_palette_logique,
              Sizeof(tLogPalette)+ (l_nombre_couleurs- 1)* Sizeof(tPaletteEntry));

          with l_pt_palette_logique^ do
          begin
            palVersion:= $0300;
            palNumEntries:= l_nombre_couleurs;
            for l_indice:= 0 to l_nombre_couleurs do
              (*$r-*)
              with palPalEntry[l_indice], l_pt_info_bitmap_dib^.bmiColors[l_indice] do
              (*$r+*)
              begin
                peRed:= rgbRed;
                peBlue:= rgbBlue;
                peGreen:= rgbGreen;
                peFlags:= 0;
                (* inverse rouge et bleu
                move(l_pt_palette^, palPalEntry, l_nombre_couleurs* 4);
                *)
              end;
          end; (* with*)
        end;

        pv_poignee_palette:= CreatePalette(l_pt_palette_logique^);
        (* -- rend la mmoire des informations de palette *)
        FreeMem(l_pt_palette_logique,
            Sizeof(tLogPalette)+ (l_nombre_couleurs- 1)* Sizeof(tPaletteEntry));
      end; (* cree_palette *)

    procedure affiche_dib;
      var l_poignee_contexte_ecran: hDC;
          l_poignee_palette, l_poignee_palette_precedente: hPalette;
      begin (* affiche_dib *)
        with l_pt_info_bitmap_dib^, bmiHeader do
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          (* -- charge la palette du DIB dans le contexte *)
          cree_palette(l_poignee_palette);
          l_poignee_palette_precedente:=
              SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
          RealizePalette(l_poignee_contexte_ecran);

          SetDIBitsToDevice(l_poignee_contexte_ecran,
                  p_x, p_y, biWidth, biHeight,
                  0, 0, 0, biHeight,
                  l_pt_bits,
                  l_pt_info_bitmap_dib^,
                  DIB_RGB_Colors);

          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, True);
          DeleteObject(l_poignee_palette);

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* with *)
      end; (* affiche_dib *)

    begin (* charge_et_affiche_bmp *)
      charge_en_memoire;
      cree_dib;
      affiche_dib;

      GlobalUnlock(l_poignee_bits);
      GlobalFree(l_poignee_bits);
      FreeMem(l_pt_info_bitmap_dib, l_taille_en_tete_et_palette);
    end; (* charge_et_affiche_bmp *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_rouge: Byte= 1; ls_vert: Byte= 0; ls_bleu: Byte= 1;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure cree_palette(p_rouge, p_vert, p_bleu: Byte; var pv_poignee_palette: hPalette);
        var l_pt_palette_logique: ^tLogPalette;
            l_indice: Word;
        begin
          GetMem(l_pt_palette_logique, Sizeof(tLogPalette)+ 235* Sizeof(tPaletteEntry));

          with l_pt_palette_logique^ do
          begin
            palVersion:= $0300;
            palNumEntries:= 236;
            for l_indice:= 0 to 235 do
              (*$r-*)
              with palPalEntry[l_indice] do
              (*$r+*)
              begin
                peRed:= p_rouge* (255- l_indice);
                peGreen:= p_vert* (255- l_indice);
                peBlue:= p_bleu* (255- l_indice);
                peFlags:= 0;
              end; (* for with *)
          end; (* with*)
          pv_poignee_palette:= CreatePalette(l_pt_palette_logique^);

          FreeMem(l_pt_palette_logique, Sizeof(tLogPalette)+ 235* Sizeof(tPaletteEntry));
        end; (* cree_palette *)

      procedure sauve_dans_bmp;
        var l_poignee_contexte_ecran: hDC;

        procedure dessine_un_peu;
          var l_x, l_y: Word;
          begin
            for l_x:= 0 to 50 do
              for l_y:= 0 to 20 do
                SetPixel(l_poignee_contexte_ecran, l_x+ 2, l_y+ 2, $01000000+ l_x* 5);
          end; (* dessine_un_peu *)

        var l_poignee_palette, l_poignee_palette_precedente: hPalette;

        begin (* sauved_dans_bmp *)
          affiche_palette_systeme(p_poignee_fenetre, 100, 0, 5);

          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          cree_palette(ls_rouge, ls_vert, ls_bleu, l_poignee_palette);

          l_poignee_palette_precedente:=
              SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
          RealizePalette(l_poignee_contexte_ecran);

          dessine_un_peu;
          cree_bmp(l_poignee_contexte_ecran, -20, -35, 128, 64, 'sauve.bmp');

          (* -- efface *)
          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, True);
          DeleteObject(l_poignee_palette);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* sauve_dans_bmp *)

      procedure modifie_palette(p_rouge, p_vert, p_bleu: Byte);
        var l_poignee_palette, l_poignee_palette_precedente: hPalette;
            l_poignee_contexte_ecran: hDC;
        begin (* sauved_dans_bmp *)
          ls_rouge:= p_rouge; ls_vert:= p_vert; ls_bleu:= p_bleu;

          affiche_palette_systeme(p_poignee_fenetre, 100, 0, 5);

          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          cree_palette(p_rouge, p_vert, p_bleu, l_poignee_palette);
          l_poignee_palette_precedente:=
              SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
          RealizePalette(l_poignee_contexte_ecran);

          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, True);
          DeleteObject(l_poignee_palette);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* modifie_palette *)

      procedure charge_la_bmp;
        begin
          charge_et_affiche_bmp(p_poignee_fenetre, 200, 10, 'sauve.bmp');
        end; (* charge_la_bmp *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'S' : sauve_dans_bmp;
          'P' : affiche_palette_systeme(p_poignee_fenetre, 100, 0, 5);
          'R' : modifie_palette(1, 0, 0);
          'V' : modifie_palette(0, 1, 0);
          'J' : modifie_palette(1, 1, 0);
          'B' : modifie_palette(0, 0, 1);
          'C' : charge_la_bmp;
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- paramtre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
