(* 002 brosse *)
(* 15 sep 94 *)

(*$r+ *)
program illustre_brosses;
  uses WinTypes, WinProcs, Strings;

  (*$r brosse *)

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe brosses';
        k_titre_fenetre= 'Stock, sOlide, Hachuree, bitmap Disque, Bitmap, Aligne';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      const k_largeur= 100; k_hauteur= 30;
      var l_poignee_contexte_ecran: hDC;

      procedure affiche_xy(p_x, p_y: Word; p_chaine: String);
        begin
          TextOut(l_poignee_contexte_ecran, p_x, p_y, @p_chaine[1], Length(p_chaine));
        end; (* affiche_xy *)

      procedure affiche_brosse_en_stock(p_x: Word);
        var l_type: Byte;
            l_poignee_brosse: hBrush;
        begin
          affiche_xy(0, 0, 'en stock:');
          Moveto(l_poignee_contexte_ecran, p_x+ k_largeur div 2, 20);
          Lineto(l_poignee_contexte_ecran, p_x+ k_largeur div 2, 300);

          for l_type:= 0 to 5 do
          begin
            case l_type of
              0 : l_poignee_brosse:= GetStockObject(Black_Brush);
              1 : l_poignee_brosse:= GetStockObject(DkGray_Brush);
              2 : l_poignee_brosse:= GetStockObject(Gray_Brush);
              3 : l_poignee_brosse:= GetStockObject(LtGray_Brush);
              4 : l_poignee_brosse:= GetStockObject(White_Brush);
              5 : l_poignee_brosse:= GetStockObject(Null_Brush);
            end;

            SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
            Rectangle(l_poignee_contexte_ecran, p_x, 20+ l_type* k_hauteur, p_x+ k_largeur,
                10+ (l_type+ 1)* k_hauteur);
          end;
        end; (* affiche_brosse_en_stock *)

      procedure affiche_brosse_solide(p_x: Word);
        var l_poignee_brosse_rgb, l_poignee_brosse_indice, l_poignee_brosse_palette_rgb: hBrush;
        begin
          affiche_xy(p_x, 0, 'solides:');
          l_poignee_brosse_rgb:= CreateSolidBrush(180);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse_rgb);
          Rectangle(l_poignee_contexte_ecran, p_x, 20, p_x+ k_largeur, 10+ k_hauteur);

          l_poignee_brosse_indice:= CreateSolidBrush($01000000+ 180);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse_indice);
          Rectangle(l_poignee_contexte_ecran, p_x, 20+ k_hauteur, p_x+ k_largeur, 10+ 2* k_hauteur);

          l_poignee_brosse_palette_rgb:= CreateSolidBrush($02000000+ 180);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse_palette_rgb);
          Rectangle(l_poignee_contexte_ecran, p_x, 20+ 2* k_hauteur, p_x+ k_largeur,
              10+ 3* k_hauteur);

          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse_rgb);
          DeleteObject(l_poignee_brosse_indice);
          DeleteObject(l_poignee_brosse_palette_rgb);
        end; (* affiche_brosse_solide *)

      procedure affiche_brosse_hachuree(p_x: Word);
        var l_type: Byte;
            l_poignee_brosse: hBrush;
        begin
          affiche_xy(p_x, 0, 'hachuree:');
          Moveto(l_poignee_contexte_ecran, p_x+ k_largeur div 2, 20);
          Lineto(l_poignee_contexte_ecran, p_x+ k_largeur div 2, 300);

          for l_type:= 0 to 5 do
          begin
            case l_type of
              0 : l_poignee_brosse:= CreateHatchBrush(hs_Vertical, 255);
              1 : l_poignee_brosse:= CreateHatchBrush(hs_Horizontal, $0000FF00);
              2 : l_poignee_brosse:= CreateHatchBrush(hs_Cross, $00FF0000);
              3 : l_poignee_brosse:= CreateHatchBrush(hs_FDiagonal, $0000007F);
              4 : l_poignee_brosse:= CreateHatchBrush(hs_BDiagonal, $00007F00);
              5 : l_poignee_brosse:= CreateHatchBrush(hs_DiagCross, $007F0000);
            end;

            (* -- un coup sur deux opaque ou transparent *)
            if l_type mod 2= 0
              then SetBkMode(l_poignee_contexte_ecran, Transparent)
              else SetBkMode(l_poignee_contexte_ecran, Opaque);

            (* -- change le fond. N'aura aucun effet en mode transparent *)
            SetBkColor(l_poignee_contexte_ecran, $01000000+ l_type);

            SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
            Rectangle(l_poignee_contexte_ecran, p_x, 20+ l_type* k_hauteur, p_x+ k_largeur,
                10+ (l_type+ 1)* k_hauteur);

            SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
            DeleteObject(l_poignee_brosse);
          end;
        end; (* affiche_brosse_hachuree *)

      procedure affiche_brosse_bitmap_disque(p_x: Word);
        var l_poignee_brosse: hBrush;
            l_poignee_bitmap: hBitmap;
        begin
          affiche_xy(p_x, 0, 'bitmap:');
          l_poignee_bitmap:= LoadBitmap(g_Instance, 'MA_BROSS');
          l_poignee_brosse:= CreatePatternBrush(l_poignee_bitmap);
          DeleteObject(l_poignee_bitmap);

          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);

          Rectangle(l_poignee_contexte_ecran, p_x, 20, p_x+ k_largeur, 10+ 3* k_hauteur);

          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);
        end; (* affiche_brosse_bitmap_disque *)

      procedure affiche_brosse_bitmap(p_x: Word);
        const k_table_bits: array[0..7] of Word
            = ($00, $7E, $7E, $7E, $7E, $7E, $7E, $00);
        var l_poignee_bitmap: hBitmap;
            l_poignee_brosse: hBrush;
        begin
          l_poignee_bitmap:= CreateBitmap(8, 8, 1, 1, @k_table_bits);
          l_poignee_brosse:= CreatePatternBrush(l_poignee_bitmap);
          DeleteObject(l_poignee_bitmap);

          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);

          Rectangle(l_poignee_contexte_ecran, p_x, 20+ 3* k_hauteur, p_x+ k_largeur,
              10+ 6* k_hauteur);

          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);
        end; (* affiche_brosse_bitmap *)

      procedure decale_origine(p_x: Word);
        var l_poignee_brosse: hBrush;
            l_mois: Word;

            l_poignee_brosse_alignee, l_poignee_brosse_precedente: hBrush;
            l_sommet: tPoint;
        begin
          affiche_xy(p_x, 0, 'aligne:');

          l_poignee_brosse:= CreateHatchBrush(hs_FDiagonal, $0000007F);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
          for l_mois:= 0 to 3 do
            Rectangle(l_poignee_contexte_ecran, p_x+ l_mois* 15, 40- 5* l_mois,
                p_x+ (l_mois+ 1)* 15, 100);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);

          (* -- cr une brosse *)
          l_poignee_brosse_alignee:= CreateHatchBrush(hs_FDiagonal, $0000007F);
          for l_mois:= 0 to 3 do
          begin
            (* -- bouge l'origine de la brosse: *)
            (* --   le coin suprieur gauche du dessin *)
            l_sommet.x:= p_x+ l_mois* 15;
            l_sommet.y:= 40- 5* l_mois+ 100;
            (* --   convertit des coordonnes logiques en coordonnes priphrique *)
            LpToDp(l_poignee_contexte_ecran, l_sommet, 1);
            (* --   dfinis la nouvelle origine du motif *)
            SetBrushOrg(l_poignee_contexte_ecran, l_sommet.x, l_sommet.y);

            (* -- appelle UnrealizeObject pour pouvoir modifier l'origine *)
            UnrealizeObject(l_poignee_brosse_alignee);

            l_poignee_brosse_precedente:= SelectObject(l_poignee_contexte_ecran,
                l_poignee_brosse_alignee);
            Rectangle(l_poignee_contexte_ecran, p_x+ l_mois* 15, 20- 5* l_mois+ 100,
                p_x+ (l_mois+ 1)* 15, 80+ 100);
            SelectObject(l_poignee_contexte_ecran, l_poignee_brosse_precedente);
          end; (* for *)
          DeleteObject(l_poignee_brosse);
        end; (* decale_orignie *)

      begin (* traite_wm_char *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        case Upcase(p_caractere) of
          'S' : affiche_brosse_en_stock(0);
          'O' : affiche_brosse_solide(k_largeur+ 10);
          'H' : affiche_brosse_hachuree(2* (k_largeur+ 10));

          'D' : affiche_brosse_bitmap_disque(3* (k_largeur+ 10));
          'B' : affiche_brosse_bitmap(3* (k_largeur+ 10));

          'A' : decale_origine(4* (k_largeur+ 10));
        end; (* case *)

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- paramtre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
