(* 002 devcap *)
(* 02 aou 94 *)

(*$r+ *)
program illustre_paint;
  uses WinTypes, WinProcs, Strings, Win31;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe dev caps';
        k_titre_fenetre= 'Base, Matricielle, Courbes, Lignes, Polygones, Texte';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      var l_poignee_contexte_ecran: hDC;
          l_metrique_police: tTextMetric;
          l_hauteur_caractere, l_y: Word;

      procedure affiche(p_texte: String);
        begin
          TextOut(l_poignee_contexte_ecran, 0, l_y, @p_texte[1], Length(p_texte));
          inc(l_y, l_hauteur_caractere);
        end; (* affiche *)

      function f_possibilite(p_code_possibilite: Word): String;
        var l_valeur: Integer;
            l_chaine: string;
        begin
          l_valeur:= GetDeviceCaps(l_poignee_contexte_ecran, p_code_possibilite);
          str(l_valeur, l_chaine);
          f_possibilite:= l_chaine;
        end; (* f_possibilite *)

      procedure affiche_possibilites_de_base;
        begin
          affiche('DriverVersion: Version du pilote: '+ f_possibilite(DriverVersion));

          Case GetDeviceCaps(l_poignee_contexte_ecran, Technology) of
            dt_Plotter : affiche('Technology: dt_Plotter: traceur');
            dt_RasPrinter : affiche('Technology: dt_RasPlotter: imprimante matricielle');
            dt_RasDisplay : affiche('Technology:    dt_RasDisplay:     cran matriciel');
            dt_RasCamera : affiche('Technology: dt_RasCamera: camra');
            dt_CharStream : affiche('Technology: dt_CharStream: terminal');
            dt_MetaFile : affiche('Technology: dt_MetaFile: mta fichier');
            dt_DispFile : affiche('Technology: dt_DispFile: fichier');
            else affiche('Technology: ???');
          End;

          affiche('HorzSize:      largeur en mm:     '+ f_possibilite(HorzSize));
          affiche('VertSize:      hauteur en mm:     '+ f_possibilite(VertSize));
          affiche('HorzRes:       largeur en pixels: '+ f_possibilite(HorzRes));
          affiche('VertRes:       hauteur en pixels: '+ f_possibilite(VertRes));
          affiche('LogPixelsX:    taille logique:    '+ f_possibilite(LogPixelsX));
          affiche('LogPixelsY:    taille logique:    '+ f_possibilite(LogPixelsY));
          affiche('BitsPixel:     bits par pixel:    '+ f_possibilite(BitsPixel));
          affiche('Planes:        bits par pixel:    '+ f_possibilite(Planes));
          affiche('NumBrushes:    nombre de brosses: '+ f_possibilite(NumBrushes));
          affiche('NumPens:       nombre de crayons: '+ f_possibilite(NumPens));
          affiche('NumMarkers:    nombre de markers: '+ f_possibilite(NumMarkers));
          affiche('NumFonts:      nombre de polices: '+ f_possibilite(NumFonts));
          affiche('NumColors:     nombre de couleurs:'+ f_possibilite(NumColors));
          affiche('AspectX:       ratio aspect X:    '+ f_possibilite(AspectX));
          affiche('AspectY:       ratio aspect Y:    '+ f_possibilite(AspectY));
          affiche('pDeviceSize:   octets pDevice:    '+ f_possibilite(pDeviceSize));

          Case GetDeviceCaps(l_poignee_contexte_ecran, ClipCaps) of
            cp_None :      affiche('ClipCap:       cp_None:           aucune');
            cp_Rectangle:  affiche('ClipCap:       cp_Rectangle:      rectangles');
            cp_Region :    affiche('ClipCap (3.1): cp_Region:         region');
          end;

          affiche('SizePalette:   taille palette:    '+ f_possibilite(SizePalette));
          affiche('NumReserved:   couleurs rserves:'+ f_possibilite(NumReserved));
          affiche('ColorRes:      rsolution couleur:'+ f_possibilite(ColorRes));
        end; (* affiche_possibilites_de_base *)

      var l_possibilite: Integer;

      function f_oui_non(p_code_possibilite: Integer): String;
        begin
          if (GetDeviceCaps(l_poignee_contexte_ecran, l_possibilite) And p_code_possibilite)= 0
            then f_oui_non:= 'non'
            else f_oui_non:= 'oui';
        end; (* f_oui_non *)

      procedure affiche_possibilites_matricielles;
        begin
          l_possibilite:= RasterCaps;
          affiche('rc_Banding:       dcoupe impression en bandes      '+ f_oui_non(rc_Banding));
          affiche('rc_BigFont:       utilise des grosses polices       '+ f_oui_non(rc_BigFont));
          affiche('rc_BitBlt:        peut copier des bits              '+ f_oui_non(rc_BitBlt));
          affiche('rc_Bitmap64:      accepte des bitmaps > 64K         '+ f_oui_non(rc_Bitmap64));
          (*
          affiche('rc_DevBits:       accepte des bitmaps priphriques '+ f_oui_non(rc_DevBits));
          *)
          affiche('rc_di_Bitmap:     acceptes des bitmaps DIB          '+ f_oui_non(rc_di_Bitmap));
          affiche('rc_DibToDev:      traite DibToDev                   '+ f_oui_non(rc_DibToDev));
          affiche('rc_FloodFill:     peut remplir des contours         '+ f_oui_non(rc_FloodFill));
          affiche('rc_GDI20_Output:  traite les appels Windows 2.0     '+ f_oui_non(rc_GDI20_Output));
          affiche('rc_GDI20_State:   utilise des blocs Windows 2.0     '+ f_oui_non(rc_GDI20_State));
          (*
          affiche('rc_None:          pas de traitement matriciel       '+ f_oui_non(rc_None));
          *)
          affiche('rc_Palette:       utilise une palette               '+ f_oui_non(rc_Palette));
          affiche('rc_SaveBitmap:    sauve localeement les bitmaps     '+ f_oui_non(rc_SaveBitmap));
          affiche('rc_Scaling:       peut tirer                       '+ f_oui_non(rc_Scaling));
          affiche('rc_StretchBlt:    supporte StretchBlt               '+ f_oui_non(rc_StretchBlt));
          affiche('rc_StretchDib:    supporte StretchDIB               '+ f_oui_non(rc_StretchDib));
        end; (* affiche_possibilites_matricielles *)

      procedure affiche_possibilites_courbes;
        begin
          l_possibilite:= CurveCaps;
          affiche('cc_None:       aucune                  '+ f_oui_non(cc_None));
          affiche('cc_Circles:    cercles                 '+ f_oui_non(cc_Circles));
          affiche('cc_Chord:      corde et arc            '+ f_oui_non(cc_Chord));
          affiche('cc_Ellipses:   ellipses                '+ f_oui_non(cc_Ellipses));
          affiche('cc_Wide:       bords pais             '+ f_oui_non(cc_Wide));
          affiche('cc_Styled:     bords avec effets       '+ f_oui_non(cc_Styled));
          affiche('cc_WideStyled: bords avec effets pais '+ f_oui_non(cc_WideStyled));
          affiche('cc_Interiors:  intrieurs              '+ f_oui_non(cc_Interiors));
          affiche('cc_RoundRect:  rectangles arrondis     '+ f_oui_non(cc_RoundRect));
        end; (* affiche_possibilites_courbes *)

      procedure affiche_possibilites_lignes;
        begin
          l_possibilite:= LineCaps;
          affiche('lc_None:       aucune                      '+ f_oui_non(lc_None));
          affiche('lc_PolyLine:   ligne brise                '+ f_oui_non(lc_PolyLine));
          affiche('lc_Marker:     marqueurs                   '+ f_oui_non(lc_Marker));
          affiche('lc_PolyMarker: ligne brise avec marqueurs '+ f_oui_non(lc_PolyMarker));
          affiche('lc_Wide:       ligne paisse               '+ f_oui_non(lc_Wide));
          affiche('lc_Styled:     ligne avec effets           '+ f_oui_non(lc_Styled));
          affiche('lc_WideStyled: ligne avec effets pais     '+ f_oui_non(lc_WideStyled));
          affiche('lc_Interiors:  intrieurs                  '+ f_oui_non(lc_Interiors));
        end; (* affiche_possibilites_lignes *)

      procedure affiche_possibilites_polygones;
        begin
          l_possibilite:= PolygonalCaps;
          affiche('pc_None:        aucune                      '+ f_oui_non(pc_None));
          affiche('pc_Polygon:     polygones alterns          '+ f_oui_non(pc_Polygon));
          affiche('pc_Rectangle:   rectangles                  '+ f_oui_non(pc_Rectangle));
          affiche('pc_WindPolygon: polygones alterns Windows  '+ f_oui_non(pc_WindPolygon));
          affiche('pc_ScanLine:    ligne de balayage           '+ f_oui_non(pc_ScanLine));
          affiche('pc_Wide:        ligne paisse               '+ f_oui_non(pc_Wide));
          affiche('pc_Styled:      ligne avec effets           '+ f_oui_non(pc_Styled));
          affiche('pc_WideStyled:  ligne avec effets pais     '+ f_oui_non(pc_WideStyled));
          affiche('pc_Interiors:   intrieurs                  '+ f_oui_non(pc_Interiors));
        end; (* affiche_possibilites_polygones *)

      procedure affiche_possibilites_texte;
        begin
          l_possibilite:= TextCaps;
          affiche('tc_op_Character: placement au pixel         '+ f_oui_non(tc_op_Character));
          affiche('tc_op_Stroke:    peut supprimer des traits  '+ f_oui_non(tc_op_Stroke));
          affiche('tc_cp_Stroke:    peut clipper un caractre  '+ f_oui_non(tc_cp_Stroke));
          affiche('tc_cr_90:        rotation de 90 degrs      '+ f_oui_non(tc_cr_90));
          affiche('tc_cr_Any:       rotation quelconque        '+ f_oui_non(tc_cr_Any));
          affiche('tc_sf_x_yIndep:  chelles x y indpendantes '+ f_oui_non(tc_sf_x_yIndep));
          affiche('tc_sa_Double:    peut doubler               '+ f_oui_non(tc_sa_Double));
          affiche('tc_sa_Integer:   peut multiplier par entier '+ f_oui_non(tc_sa_Integer));
          affiche('tc_sa_Contin:    peut multiplier par rel   '+ f_oui_non(tc_sa_Contin));
          affiche('tc_ea_Double:    peut crer du gras         '+ f_oui_non(tc_ea_Double));
          affiche('tc_ia_Able:      peut crer de l''italique   '+ f_oui_non(tc_ia_Able));
          affiche('tc_ua_Able:      peut crer du soulign     '+ f_oui_non(tc_ua_Able));
          affiche('tc_so_Able:      peut crer du biff        '+ f_oui_non(tc_so_Able));
          affiche('tc_ra_Able:      peut crer pol matricielle '+ f_oui_non(tc_ra_Able));
          affiche('tc_va_Able:      peut crer pol vectorielle '+ f_oui_non(tc_va_Able));
        end; (* affiche_possibilites_texte *)

      begin (* traite_wm_char *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));

        GetTextMetrics(l_poignee_contexte_ecran, l_metrique_police);
        l_hauteur_caractere:= l_metrique_police.tmHeight;

        l_y:= 0;

        case Upcase(p_caractere) of
          'B' : affiche_possibilites_de_base;
          'M' : affiche_possibilites_matricielles;
          'C' : affiche_possibilites_courbes;
          'L' : affiche_possibilites_lignes;
          'P' : affiche_possibilites_polygones;
          'T' : affiche_possibilites_texte;
        end; (* case *)

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touches en messages caractres *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

