(* 002 dibres *)
(* 12 sep 94 *)

(*$r+ *)
program affiche_dib_cree_par_workshop;
  uses WinTypes, WinProcs, Strings, Win31;

  (*$r image2 *)

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe dibres';
        k_titre_fenetre= 'Bitmap, Resource, Systme';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_entier_long_chaine(p_entier_long: LongInt): string;
    var l_chaine: string;
    begin
      str(p_entier_long, l_chaine);
      f_entier_long_chaine:= l_chaine;
    end; (* f_entier_long_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

     procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure charge_bitmap;
        var l_poignee_contexte_ecran: hDC;
            l_poignee_contexte_memoire: hDC;
            l_poignee_bitmap, l_poignee_bitmap_precedente: hBitmap;
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          (* -- copie les attributs du contexte dans dc_mmoire *)
          l_poignee_contexte_memoire:= CreateCompatibleDc(l_poignee_contexte_ecran);

          l_poignee_bitmap:= LoadBitmap(g_Instance, 'BITMAP_1');

          l_poignee_bitmap_precedente:= SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap);
          BitBlt(l_poignee_contexte_ecran, 10, 10, 64, 64, l_poignee_contexte_memoire, 0, 0, SrcCopy);

          (* -- replace la bitmap originale *)
          SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap_precedente);
          DeleteDc(l_poignee_contexte_memoire);
          DeleteObject(l_poignee_bitmap);

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* charge_bitmap *)

      procedure charge_resource;
        var l_poignee_contexte_ecran: hDC;
            l_y: Word;

        procedure affiche(p_chaine: String);
          begin
            TextOut(l_poignee_contexte_ecran, 85, l_y, @p_chaine[1], Length(p_chaine));
            Inc(l_y, 20);
          end; (* affiche *)

        procedure affiche_en_tete_dib(p_pt_en_tete_dib: pBitmapInfo);

          function f_taille_palette: Word;
            (* -- calcule la taille de la palette *)
            var l_nombre_couleurs: Word;
            begin
              with p_pt_en_tete_dib^, bmiHeader do
              begin
                if biClrUsed> 0
                  then l_nombre_couleurs:= biClrUsed
                  else
                    case biBitCount of
                      1 : l_nombre_couleurs:= 2;
                      4 : l_nombre_couleurs:= 16;
                      8 : l_nombre_couleurs:= 256;
                      else l_nombre_couleurs:= 0;
                    end;

                f_taille_palette:= 4* l_nombre_couleurs;
              end; (* l_nombre_couleurs *)
            end; (* f_taille_palette *)

          begin (* affiche_en_tete_dib *)
            with p_pt_en_tete_dib^, bmiHeader do
            begin
              affiche('biSize:      taille en-tte  '+ f_entier_long_chaine(biSize));
              affiche('biWidth:     pixels de large '+ f_entier_long_chaine(biWidth));
              affiche('biHeight:    pixels de haut  '+ f_entier_long_chaine(biHeight));
              affiche('biPlanes:    plans           '+ f_mot_chaine(biPlanes));
              affiche('biBitCount:  bits/pixel      '+ f_mot_chaine(biBitCount));
              Case biCompression of
                bi_RGB :  affiche('biCompression=bi_RGB         Sans');
                bi_RLE8 : affiche('biCompression=bi_RLE8        Run Length 8');
                bi_RLE4 : affiche('biCompression=bi_RLE4        Run Length 4');
              end;
              affiche('biSizeImage  octets image    '+ f_entier_long_chaine(biSizeImage));
              affiche('biClrUsed                    '+ f_entier_long_chaine(biClrUsed));
              affiche('             taille palette  '+ f_entier_long_chaine(f_taille_palette));
            end; (* affiche_en_tete_dib *)
          end; (* affiche_en_tete_dib *)

        procedure affiche_resource(p_pt_en_tete_dib: pBitmapInfo);
          type t_adresse= record
                            offset, segment: Word;
                          end;
          var l_pt_bits: Pointer;
              l_calcule: t_adresse absolute l_pt_bits;
          begin
            l_pt_bits:= p_pt_en_tete_dib;
            with p_pt_en_tete_dib^, bmiHeader do
            begin
              l_calcule.offset:= l_calcule.offset+ biSize;
              if biClrUsed= 0
                then
                  case biBitCount of
                    1 : ;
                    4 : l_calcule.offset:= l_calcule.offset+ 16*4;
                    8 : l_calcule.offset:= l_calcule.offset+ 256*4;
                  end;
            end; (* with *)

            SetDIBitsToDevice(l_poignee_contexte_ecran,
                (* -- position affichage *)
                450, 5, 64, 64,
                (* -- point origine *)
                0, 0,
                (* -- ligne de balayage dbut, nombre lignes  copier *)
                0, 64,
                l_pt_bits,
                p_pt_en_tete_dib^,
                DIB_RGB_Colors);

            StretchDIBits(l_poignee_contexte_ecran,
                (* -- position et taille affichage *)
                450, 90, 128, 40,
                (* -- point et taille origine *)
                0, 0, 64, 64,
                l_pt_bits,
                p_pt_en_tete_dib^,
                DIB_RGB_Colors,
                SrcCopy);
          end; (* affiche_resource *)

        var l_poignee_resource_bitmap: tHandle;
            l_poignee_bitmap: hBitmap;
            l_pt_info_bitmap: pBitmapInfo;

        begin (* charge_resource *)
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          l_y:= 20; SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));

          (* -- cherche la bitmap dans les resources du .EXE *)
          l_poignee_resource_bitmap:= FindResource(g_Instance, 'BITMAP_1', rt_Bitmap);
          (* -- charge en mmoire *)
          l_poignee_bitmap:= LoadResource(g_instance, l_poignee_resource_bitmap);
          (* -- rcupre un pointeur vers la bitmap *)
          l_pt_info_bitmap:= LockResource(l_poignee_bitmap);

          affiche_en_tete_dib(l_pt_info_bitmap);
          affiche_resource(l_pt_info_bitmap);

          (* -- supprime les objets graphiques *)
          UnlockResource(l_poignee_bitmap);
          FreeResource(l_poignee_bitmap);

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* charge_resource *)

      procedure charge_bitmap_systeme;
        var l_poignee_contexte_ecran: hDC;
            l_poignee_contexte_memoire: hDC;
            l_poignee_bitmap, l_poignee_bitmap_precedente: hBitmap;
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          (* -- copie les attributs du contexte dans dc_mmoire *)
          l_poignee_contexte_memoire:= CreateCompatibleDc(l_poignee_contexte_ecran);

          l_poignee_bitmap:= LoadBitmap(0, MakeIntResource(32753));

          l_poignee_bitmap_precedente:= SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap);
          BitBlt(l_poignee_contexte_ecran, 550, 10, 64, 64, l_poignee_contexte_memoire, 0, 0, SrcCopy);

          (* -- replace la bitmap originale *)
          SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap_precedente);
          DeleteDc(l_poignee_contexte_memoire);
          DeleteObject(l_poignee_bitmap);

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* charge_bitmap_systeme *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'B' : charge_bitmap;
          'R' : charge_resource;
          'S' : charge_bitmap_systeme;
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- paramtre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

