(* 002 mapmode *)
(* 05 sep 94 *)

(*$r+ *)
program illustre_mapping_modes;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe mapmode';
        k_titre_fenetre= 'mm_Text, mm_LoMetric, mm_Isotropic, mm_Anisotropic';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_entier_chaine(p_entier: Integer): string;
    var l_chaine: string;
    begin
      str(p_entier, l_chaine);
      f_entier_chaine:= l_chaine;
    end; (* f_entier_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_rectangle: tRect= (Left: 110; Top: 110; Right: 210; Bottom: 210);
          ls_mode: Word= mm_AnIsotropic;
          ls_largeur: Integer= 100;
          ls_hauteur: Integer= 100;

    function f_mode(p_mode: Word): String;
      begin
        case p_mode of
          mm_Text: f_mode:= 'mm_Text';
          mm_LoMetric : f_mode:= 'mm_LoMetric';
          mm_IsoTropic : f_mode:= 'mm_Isotropic';
          mm_AnIsoTropic : f_mode:= 'mm_AnIsotropic';
        end; (* case *)
      end; (* f_mode *)

    procedure traite_wm_paint;
      var l_poignee_contexte_ecran: hDC;
          l_structure_dessin: tPaintStruct;
          l_y: Integer;

      procedure affiche(p_texte: String);
        begin
          TextOut(l_poignee_contexte_ecran, 120, l_y, @p_texte[1], Length(p_texte));
          inc(l_y, 20);
        end; (* affiche *)

      var l_pixels_x, l_pixels_y: Integer;

      begin (* traite_mwPaint *)
        l_poignee_contexte_ecran:= BeginPaint(p_poignee_fenetre, l_structure_dessin);

        Rectangle(l_poignee_contexte_ecran, 0, 0, 100, 100);

        with ls_rectangle do
        begin
          (* -- rajuste en fonction du mode *)
          case ls_mode of
            mm_Text : begin
                        Right:= Left+ 100;
                        Bottom:= Top+ 100;
                      end;
            mm_LoMetric : ;
            mm_IsoTropic : if Bottom> Top
                             then Bottom:= Top+ Abs(Right- Left)
                             else Bottom:= Top- Abs(Right- Left);
            end; (* case *)

          Moveto(l_poignee_contexte_ecran, Left, Top);
          LineTo(l_poignee_contexte_ecran, Right, Top);
          Moveto(l_poignee_contexte_ecran, Left, Top);
          LineTo(l_poignee_contexte_ecran, Left, Bottom);

          ls_largeur:= Right- Left;
          ls_hauteur:= Bottom- Top;

          l_y:= 120;
          affiche(f_mode(ls_mode));
          affiche('SetViewportExt(dc, '+ f_entier_chaine(ls_largeur)+ ', '
              + f_entier_chaine(ls_hauteur)+ ');');
          affiche('SetWindowExt(dc, 100, 100);');
          affiche('SetViewportOrg(dc, '+ f_entier_chaine(Left)+ ', '+ f_entier_chaine(Top)+ ');');
        end;

        EndPaint(p_poignee_fenetre, l_structure_dessin);
      end; (* traite_wmPaint *)

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      begin
        case Upcase(p_caractere) of
          'T' : ls_mode:= mm_Text;
          'L' : ls_mode:= mm_LoMetric;
          'I' : ls_mode:= mm_IsoTropic;
          'A' : ls_mode:= mm_AnIsoTropic
        end; (* case *)
        InvalidateRect(p_poignee_fenetre, nil, True);
      end; (* traite_wm_char *)

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      begin
        ls_rectangle.Left:= p_x; ls_rectangle.Top:= p_y;
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_l_button_up(p_bouton_ou_touche: Word; p_x, p_y: integer);
      begin
        ls_rectangle.Right:= p_x; ls_rectangle.Bottom:= p_y;
        InvalidateRect(p_poignee_fenetre, nil, True);
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_mouse_move(p_bouton_ou_touche: Word; p_x, p_y: integer);
      var l_poignee_contexte_ecran: hDC;
          l_position: String;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        l_position:= 'pixel_x= '+ f_entier_chaine(p_x)+ ', pixel_y= '+ f_entier_chaine(p_y)+ '     ';
        TextOut(l_poignee_contexte_ecran, 120, 0, @l_position[1], Length(l_position));

        (* -- sauve pour pouvoir afficher normalement *)
        SaveDC(l_poignee_contexte_ecran);

        (* -- modifie le mode pour calculer avec DP to LP *)
        SetMapMode(l_poignee_contexte_ecran, ls_mode);
        SetViewportExt(l_poignee_contexte_ecran, ls_largeur, ls_hauteur);
        SetWindowExt(l_poignee_contexte_ecran, 100, 100);
        with ls_rectangle do
          SetViewportOrg(l_poignee_contexte_ecran, Left, Top);
        (* -- calcule la position du curseur dans le nouveau systme *)

        DPtoLP(l_poignee_contexte_ecran, p_l_param, 1);

        RestoreDC(l_poignee_contexte_ecran, -1);

        l_position:= 'logique_x= '+ f_entier_chaine(t_long_integer(p_l_param).lo)
            + ', logique_y= '+ f_entier_chaine(t_long_integer(p_l_param).hi)+ '     ';
        TextOut(l_poignee_contexte_ecran, 120, 20, @l_position[1], Length(l_position));

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_mouse_move *)
    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Paint: traite_wm_paint;
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_lButtonUp: traite_wm_l_button_up(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_MouseMove: traite_wm_mouse_move(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touches en messages caractres *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

