(* 002 messclav *)
(* 25 aou 94 *)

(*$r+ *)
program affiche_clavier;
  uses WinTypes, WinProcs, Strings;

  type t_long_word= record
                      lo, hi: Word;
                    end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe clavier';
        k_titre_fenetre= 'affiche clavier';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot: 3, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_largeur_caractere: Word= 12;
          ls_hauteur_caractere: Word= 20;
          ls_y_affichage: Word= 0;
          ls_rectangle_defilement: tRect= (Left: 0; Top: 0; Right: 0; Bottom: 0);
          ls_message_precedent: Word= 0;

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
        (* -- p_pt_create_structure (p_L_param) pointe vers une structure CREATESTRUCT *)
      var l_poignee_contexte_ecran: hDC;
          l_metrique: tTextMetric;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
        GetTextMetrics(l_poignee_contexte_ecran, l_metrique);

        with l_metrique do
        begin
          (* -- rcupre les valeurs pour afficher correctement *)
          ls_largeur_caractere:= tmAveCharWidth;
          ls_hauteur_caractere:= tmHeight;
        end; (* with l_metrique *)
        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_create *)

    procedure traite_wm_size(p_w_param: Word; p_largeur, p_hauteur: integer);
        (* -- p_w_param est le type de changement de taille *)
        (* -- p_cx (p_L_param.Lo) est la nouvelle largeur *)
        (* -- p_cy (p_L_param.Hi) est la nouvelle hauteur *)
      var l_nombre_lignes: Word;
      begin
        l_nombre_lignes:= p_hauteur div ls_hauteur_caractere;
        ls_y_affichage:= (l_nombre_lignes- 1) * ls_hauteur_caractere;

        with ls_rectangle_defilement do
        begin
          Left:= 0; Top:= 0; Right:= p_largeur; Bottom:= l_nombre_lignes* ls_hauteur_caractere;
        end;
      end; (* traite_wm_size *)

    procedure affiche_touche(p_touche: Boolean; p_nom_message: String);
      var l_poignee_contexte_ecran: hDC;

      procedure affiche_une_touche;
        var l_x: Word;

        procedure affiche(p_chaine: String);
          begin
            TextOut(l_poignee_contexte_ecran,
              l_x, ls_y_affichage,
              @p_chaine[1], Length(p_chaine));
            inc(l_x, Length(p_chaine)* ls_largeur_caractere);
          end; (* affiche *)

        begin (* affiche_une_touche *)
          l_x:= 0;

          affiche(p_nom_message);

          affiche('rpt: '+ f_mot_chaine(p_L_param and $0000FFFF));
          affiche(', scan: '+ f_mot_chaine((p_L_param shr 16) and $000000FF));

          if p_L_param and $01000000<> 0
            then affiche(', spc,  ')
            else affiche(', n-spc,');
          if p_L_param and $20000000<> 0
            then affiche(' alt,   ')
            else affiche(' n-nalt,');
          if p_L_param and $40000000<> 0
            then affiche(' enfonc,')
            else affiche(' n-enfon,');
          if p_L_param and $80000000<> 0
            then affiche(' relche,  ')
            else affiche(' presse,   ');

          affiche(f_mot_chaine(p_w_param)+ ' ');

          if p_touche
            then
              case p_w_param of
                65..90 : affiche('vk_'+ chr(p_W_param));
                48..57 : affiche('vk_'+ chr(p_W_param));
                vk_NumPad0..vk_NumPad9 :
                    affiche('vk_NumPad'+ chr(ord('0')+ p_W_param- vk_NumPad0));

                vk_LButton : affiche('vk_LButton');
                vk_RButton : affiche('vk_RButton');
                vk_Cancel : affiche('vk_Cancel (Ctrl Break)');
                vk_MButton : affiche('vk_MButton');
                vk_Back : affiche('vk_Back');
                vk_Tab : affiche('vk_Tab');
                vk_Clear : affiche('vk_Clear');
                vk_Return : affiche('vk_Return');
                vk_Shift : affiche('vk_Shift');
                vk_Control : affiche('vk_Ctrl');
                vk_Menu : affiche('vk_Menu');
                vk_Pause : affiche('vk_Pause');
                vk_Capital : affiche('vk_Capital (Caps Lock');
                vk_Escape : affiche('vk_Escape');
                vk_Space : affiche('vk_Space');
                vk_Prior : affiche('vk_Prior (Page Up)');
                vk_Next : affiche('vk_Next (Page Down)');
                vk_End : affiche('vk_End');
                vk_Home : affiche('vk_Home');
                vk_Left : affiche('vk_Left (flche)');
                vk_Up : affiche('vk_Up (flche)');
                vk_Right : affiche('vk_Right (flche)');
                vk_Down : affiche('vk_Down (flche)');
                vk_Select : affiche('vk_Select');
                vk_Print : affiche('vk_Print');
                vk_Execute : affiche('vk_Execute');
                vk_SnapShot : affiche('vk_SnapShot (Printscreen)');
                vk_Insert : affiche('vk_Insert');
                vk_Delete : affiche('vk_Delete');
                vk_Help : affiche('vk_Help');
                vk_Multiply : affiche('vk_Multiply (gray *)');
                vk_Add : affiche('vk_Add (gray +)');
                vk_Separator : affiche('vk_Separator');
                vk_Subtract : affiche('vk_Subtract (gray -)');
                vk_Decimal : affiche('vk_Decimal (numeric key pad .)');
                vk_Divide : affiche('vk_Divide (gray /)');
                vk_F1..vk_F16 : affiche('vk_F'+ chr(ord('0')+ p_W_param- vk_F1));
                vk_NumLock : affiche('vk_NumLock');

                else affiche('vk_???');
              end (* case *)
            else affiche(chr(p_w_param));
        end; (* affiche_une_touche *)

      begin (* affiche_touche *)
        (* -- droule d'une ligne *)
        if ls_message_precedent= wm_KeyUp
          then ScrollWindow(p_poignee_fenetre, 0, - 2* ls_hauteur_caractere,
              @ls_rectangle_defilement, nil)
          else ScrollWindow(p_poignee_fenetre, 0, - ls_hauteur_caractere,
              @ls_rectangle_defilement, nil);
        UpdateWindow(p_poignee_fenetre);

        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
            ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));

        affiche_une_touche;

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);

        (* -- pour sauter une ligne aprs wm_KeyUp *)
        ls_message_precedent:= p_code_message;
      end; (* affiche_touche *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create: traite_wm_create(pCreateStruct(p_l_param));
        wm_Size: traite_wm_size (p_w_param, t_long_word(p_l_param).lo, t_long_word(p_l_param).hi);

        wm_KeyDown :     affiche_touche(True, 'wm_KeyDown    ');
        wm_KeyUp:        affiche_touche(True, 'wm_KeyUp      ');

        wm_Char :        affiche_touche(False, 'wm_Char       ');

        wm_DeadChar :    affiche_touche(False, 'wm_DeadChar   ');

        wm_SysKeyDown :
          begin
            affiche_touche(True, 'wm_SysKeyDown ');
            (* -- appeler DefWindowProc *)
            l_appeler_defaut:= true;
          end;
        wm_SysKeyUp :    affiche_touche(True, 'wm_SysKeyUp   ');
        wm_SysChar :     affiche_touche(False, 'wm_SysChar    ');
        wm_SysDeadChar : affiche_touche(False, 'wm_SysDeadChar');

        wm_Destroy: traite_wm_destroy;

        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de recuperation et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- demande la conversion des messages touches en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
