(* 002 metadisq *)
(* 16 sep 94 *)

(*$r+ *)
program illustre_meta_fichier_disque;
  uses WinTypes, WinProcs, Strings, Win31;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe meta disque';
        k_titre_fenetre= 'Cr, Rejoue, Analyse';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot: 3, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure cree_meta_fichier_disque;
        var l_poignee_contexte_meta: hDC;
            l_poignee_brosse_rouge: hBrush;
            l_poignee_meta_fichier: tHandle;
        begin
          (* -- cr le mtafichier *)
          l_poignee_contexte_meta:= CreateMetafile('IMAGE.MTF');

          (* -- enregistre les appels de fonctions GDI *)
          Rectangle(l_poignee_contexte_meta, 0, 0, 100, 100);
          l_poignee_brosse_rouge:= CreateSolidBrush($000000FF);
          SelectObject(l_poignee_contexte_meta, l_poignee_brosse_rouge);
          Ellipse(l_poignee_contexte_meta, 0, 0, 50, 50);

          (* -- ferme le fichier disque *)
          l_poignee_meta_fichier:= CloseMetafile(l_poignee_contexte_meta);
          (* -- supprime le mta-fichier de la mmoire *)
          DeleteMetafile(l_poignee_meta_fichier);

          (* -- ne PAS dslectionner
          SelectObject(l_poignee_contexte_meta, GetStockObject(White_Brush));
          *)

          (* -- efface les objets graphiques *)
          DeleteObject(l_poignee_brosse_rouge);
        end; (* cree_meta_fichier_disque *)

      procedure rejoue_meta_fichier_disque;
        var l_poignee_meta_fichier: tHandle;
            l_poignee_contexte_ecran: hDC;
            l_poignee_brosse_verte: hBrush;
            l_rectangle: tRect;
            l_ligne, l_colonne: Word;
        begin
          l_poignee_meta_fichier:= GetMetafile('IMAGE.MTF');

          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          GetClientRect(p_poignee_fenetre, l_rectangle);

          SetMapmode(l_poignee_contexte_ecran, mm_AnIsotropic);
          SetViewportExt(l_poignee_contexte_ecran, l_rectangle.Right, l_rectangle.Bottom);
          SetWindowExt(l_poignee_contexte_ecran, 1000, 1000);

          l_poignee_brosse_verte:= CreateSolidBrush($0000FF00);

          For l_ligne:= 0 to 10 do
            for l_colonne:= 0 to 10 do
            begin
              SetWindowOrg(l_poignee_contexte_ecran, - l_colonne* 100, - l_ligne* 100);

              SelectObject(l_poignee_contexte_ecran, l_poignee_brosse_verte);

              PlayMetafile(l_poignee_contexte_ecran, l_poignee_meta_fichier);
            end;

          (* -- supprime le mta-fichier de la mmoire *)
          DeleteMetafile(l_poignee_meta_fichier);

          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse_verte);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* rejoue_meta_fichier_disque *)

      procedure analyse_fichier_disque;
        var l_poignee_contexte_ecran: hDC;
            l_y: Word;

        procedure affiche(p_chaine: String);
          begin
            TextOut(l_poignee_contexte_ecran, 0, l_y, @p_chaine[1], Length(p_chaine));
            Inc(l_y, 20);
          end; (* affiche_xy *)

        var l_fichier: File;
            l_en_tete: tMetaHeader;
            l_taille: LongInt;
            l_type_commande_gdi: Word;
            l_quantite, l_mot: Word;
            l_position, l_octets, l_commande: String;
        begin (* analyse_fichier_disque *)
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
          l_y:= 0;

          Assign(l_fichier, 'IMAGE.MTF');
          Reset(l_fichier, 1);

          BlockRead(l_fichier, l_en_tete, SizeOf(tMetaHeader));
          with l_en_tete do
            affiche('taille fichier: '+ f_mot_chaine(mtSize* 2));

          while not eof(l_fichier) do
          begin
            l_position:= f_mot_chaine(FilePos(l_fichier));

            BlockRead(l_fichier, l_taille, 4);
            BlockRead(l_fichier, l_type_commande_gdi, 2);
            l_octets:= ': taille '+ f_mot_chaine(l_taille* 2)+ ', type: '
                + f_mot_chaine(l_type_commande_gdi);

            case l_type_commande_gdi of
              $041B : l_commande:= ', rectangle (4 paramtres)';
              $02FC : l_commande:= ', CreateBrushIndirect (info brosse)';
              $012D : l_commande:= ', SelectObject (indice table)';
              $0418 : l_commande:= ', Ellipse (4 paramtres)';
              $0000 : l_commande:= ', fin de fichier';
              else l_commande:= ' ??'
            end; (* case *)

            (* -- avance au-del des paramtres *)
            for l_quantite:= 1 to l_taille- 2- 1 do
              BlockRead(l_fichier, l_mot, 2);

            affiche(l_position+ l_octets+ l_commande);
          end; (* while *)

          close(l_fichier);

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* analyse_fichier_disque *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'C' : cree_meta_fichier_disque;
          'R' : rejoue_meta_fichier_disque;
          'A' : analyse_fichier_disque;
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
