(* 002 palette *)
(* 09 sep 94 *)

(*$r+ *)
program illustre_palette;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe palette';
        k_titre_fenetre= 'Capacits, Systme, Dfaut, 59, 16, Rouge, Violet, Eau';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure affiche_capacites;
        var l_poignee_contexte_ecran: hDC;
            l_resultat: Integer;
            l_y: Word;

        procedure affiche(p_message: String);
          begin
            TextOut(l_poignee_contexte_ecran, 0, l_y, @p_message[1], length(p_message));
            inc(l_y, 20);
          end; (* affiche *)

        begin (* affiche_capacites *)
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));

          l_y:= 0;

          l_resultat:= GetDeviceCaps(l_poignee_contexte_ecran, RasterCaps);
          if l_resultat and rc_Palette> 0
            then begin
                affiche('RasterCaps AND rc_Palette: driver avec palette');
                affiche('  SizePalette, taille palette:    '
                    + f_mot_chaine(GetDeviceCaps(l_poignee_contexte_ecran, SizePalette))
                    + ' registres');
                affiche('  NumReserved, couleurs systme:  '
                    + f_mot_chaine(GetDeviceCaps(l_poignee_contexte_ecran, NumReserved))
                    + ' couleurs');
                affiche('  ColorRes,    rsolution couleur '
                    + f_mot_chaine(GetDeviceCaps(l_poignee_contexte_ecran, ColorRes))
                    + ' bits');
              end
            else affiche('RasterCaps AND rc_palette     cran sans palette');

          affiche('Planes, plans du contexte:                      '
              + f_mot_chaine(GetDeviceCaps(l_poignee_contexte_ecran, Planes)));
          affiche('BitsPixel, bits / pixels du contexte:           '
              + f_mot_chaine(GetDeviceCaps(l_poignee_contexte_ecran, BitsPixel)));
          affiche('NumColors, nombre couleurs systme du contexte: '
              + f_mot_chaine(GetDeviceCaps(l_poignee_contexte_ecran, NumColors)));

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* affiche_capacites *)

      procedure affiche_contexte_y(p_poignee_contexte_ecran: hDC; p_y: Word;
          p_message: String);
        begin
          TextOut(p_poignee_contexte_ecran, 0, p_y, @p_message[1], length(p_message));
        end; (* affiche *)

      procedure affiche_palette_systeme;
        (* -- cr une palette logique et la colorie avec les couleurs de la palette systme *)
        var l_poignee_contexte_ecran: hDC;
            l_pt_info_palette_logique: ^tLogPalette;
            l_indice: Integer;

            l_poignee_palette, l_poignee_palette_precedente: hPalette;
            l_poignee_brosse_indice, l_poignee_brosse_couleur: hBrush;
            l_rectangle: tRect;
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          affiche_contexte_y(l_poignee_contexte_ecran, 0, 'palette systme');

          (* -- alloue la place pour les informations de la palette logique *)
          GetMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

          (* -- remplit les informations de la palette logique *)
          with l_pt_info_palette_logique^ do
          begin
            palVersion:= $300;
            palNumEntries:= 256;
            for l_indice:= 0 to 255 do
              (*$r-*)
              with palPalEntry[l_indice] do
              (*$r+*)
              begin
                (* -- indique que la valeur peRed est un indice dans la palette systme *)
                peFlags:= pc_Explicit;
                peRed:= l_indice;
                (* -- inutilis *)
                peGreen:= 0; peBlue:= 0;
              end;
          end;

          (* -- cre la palette logique *)
          l_poignee_palette:= CreatePalette(l_pt_info_palette_logique^);

          (* -- place la palette logique dans le contexte *)
          l_poignee_palette_precedente:=
              SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
          (* -- ajuste la palette systme en utilisant la palette du contexte *)
          RealizePalette(l_poignee_contexte_ecran);

          (* -- affiche le rsultat *)
          for l_indice:= 0 to 255 do
          begin
            (* -- couleur via PaletteIndex(indice) *)
            l_poignee_brosse_indice:= CreateSolidBrush(PaletteIndex(l_indice));
            SetRect(l_rectangle, l_indice* 3, 25, (l_indice+ 1)* 3, 25+ 12);
            FillRect(l_poignee_contexte_ecran, l_rectangle, l_poignee_brosse_indice);
            DeleteObject(l_poignee_brosse_indice);

            (* -- couleur via $01bbvvrr *)
            if (l_indice>= 10) and (l_indice< 246)
              then begin
                  l_poignee_brosse_couleur:= CreateSolidBrush($01000000+ l_indice);
                  SetRect(l_rectangle, l_indice* 3, 25+ 13, (l_indice+ 1)* 3, 50);
                  FillRect(l_poignee_contexte_ecran, l_rectangle, l_poignee_brosse_couleur);
                  DeleteObject(l_poignee_brosse_couleur);
                end;
          end; (* for *)

          (* -- dslectionne avant de dtruire *)
          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, False);
          (* -- supprime notre palette *)
          DeleteObject(l_poignee_palette);

          (* -- rend la mmoire des informations de palette *)
          FreeMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* affiche_palette_systeme *)

      procedure affiche_palette(p_poignee_contexte_ecran: hDC; p_y, p_taille: Word);
        var l_indice: Word;
            l_poignee_brosse: hBrush;
            l_rectangle, l_rectangle_client: tRect;
        begin
          for l_indice:= 0 to p_taille- 1 do
          begin
            l_poignee_brosse:= CreateSolidBrush($01000000+ l_indice);
            SetRect(l_rectangle, l_indice* 3, p_y, (l_indice+ 1)* 3, p_y+ 25);
            FillRect(p_poignee_contexte_ecran, l_rectangle, l_poignee_brosse);
            DeleteObject(l_poignee_brosse);
          end; (* for l_indice *)

          GetClientRect(p_poignee_fenetre, l_rectangle_client);
          SetRect(l_rectangle, p_taille* 3, p_y, l_rectangle_client.Right, p_y+ 25);
          FillRect(p_poignee_contexte_ecran, l_rectangle, GetStockObject(LtGray_Brush));
        end; (* affiche_palette *)

      procedure affiche_palette_par_defaut;
        (* -- utilise indice dans la palette *)
        var l_poignee_contexte_ecran: hDC;
            l_indice: Integer;
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          affiche_contexte_y(l_poignee_contexte_ecran, 52, 'DEFAULT_PALETTE');

          affiche_palette(l_poignee_contexte_ecran, 75, 20);

          (* -- ne fait rien, car ne peut pas Raliser la palette par dfaut
          RealizePalette(l_poignee_contexte_ecran);
          affiche_palette(l_poignee_contexte_ecran, 75);
          *)

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* affiche_palette_par_defaut *)

      procedure modifie_palette(p_taille: Word; p_type_palette: Char);

        procedure cree_palette(var pv_poignee_palette: hPalette);
          var l_pt_info_palette_logique: ^tLogPalette;

          procedure remplis_4_couleurs;
            var l_couleur, l_intensite, l_facteur: Integer;
                l_taille: Word;
            begin
              with l_pt_info_palette_logique^ do
              begin
                palNumEntries:= p_taille;
                FillChar(palPalEntry, palNumEntries* SizeOf(tPaletteEntry), 0);

                l_taille:= p_taille div 4;
                (* -- si ne multiplie pas, n'a que des sombres *)
                l_facteur:= 256 div l_taille;
                for l_couleur:= 0 to 3 do
                begin
                  for l_intensite:= 0 to l_taille- 1 do
                    (*$r-*)
                    with palPalEntry[l_couleur* l_taille+ l_intensite] do
                    (*$r+*)
                    begin
                      case l_couleur of
                        0 : peRed:= l_intensite* l_facteur;
                        1 : peGreen:= l_intensite* l_facteur;
                        2 : peBlue:= l_intensite* l_facteur;
                        3 : begin
                              peRed:= l_intensite* l_facteur;
                              peGreen:= peRed; peBlue:= peRed;
                            end;
                      end; (* case *)
                    end; (* for, with *)
                end; (* for l_couleur *)
              end; (* with l_pt_info_palette_logique^ *)
            end; (* remplis_4_couleurs *)

          procedure remplis_jaunes;
            var l_intensite, l_facteur: Integer;
            begin
              with l_pt_info_palette_logique^ do
              begin
                palNumEntries:= p_taille;
                FillChar(palPalEntry, palNumEntries* SizeOf(tPaletteEntry), 0);

                (* -- si ne multiplie pas, n'a que des sombres *)
                l_facteur:= 256 div p_taille;
                for l_intensite:= 0 to p_taille- 1 do
                  (*$r-*)
                  with palPalEntry[l_intensite] do
                  (*$r+*)
                  begin
                    peRed:= l_intensite* l_facteur;
                    peGreen:= l_intensite* l_facteur;
                  end; (* for, with *)
              end; (* with l_pt_info_palette_logique^ *)
            end; (* remplis_jaunes *)

          procedure remplis_rouge;
            var l_intensite: Integer;
            begin
              with l_pt_info_palette_logique^ do
              begin
                palNumEntries:= p_taille;
                FillChar(palPalEntry, palNumEntries* SizeOf(tPaletteEntry), 0);

                for l_intensite:= 0 to p_taille- 1 do
                  (*$r-*)
                  with palPalEntry[l_intensite] do
                  (*$r+*)
                  begin
                    peRed:= l_intensite;
                  end; (* for, with *)
              end; (* with l_pt_info_palette_logique^ *)
            end; (* remplis_rouge *)

          procedure remplis_violets;
            var l_intensite, l_facteur: Integer;
            begin
              with l_pt_info_palette_logique^ do
              begin
                palNumEntries:= p_taille;
                FillChar(palPalEntry, palNumEntries* SizeOf(tPaletteEntry), 0);

                (* -- si ne multiplie pas, n'a que des sombres *)
                l_facteur:= 256 div p_taille;
                for l_intensite:= 0 to p_taille- 1 do
                  (*$r-*)
                  with palPalEntry[l_intensite] do
                  (*$r+*)
                  begin
                    peRed:= l_intensite* l_facteur;
                    peBlue:= l_intensite* l_facteur;
                  end; (* for, with *)
              end; (* with l_pt_info_palette_logique^ *)
            end; (* remplis_violets *)

          procedure remplis_vert_eau;
            var l_poignee_palette_defaut: hPalette;
                l_intensite: Integer;
            begin
              with l_pt_info_palette_logique^ do
              begin
                palNumEntries:= p_taille;
                FillChar(palPalEntry, palNumEntries* SizeOf(tPaletteEntry), 0);

                (* -- rcupre les 20 entres de la palette systme *)
                l_poignee_palette_defaut:= GetStockObject(Default_Palette);
                GetPaletteEntries(l_poignee_palette_defaut, 0, 20, palPalEntry);

                for l_intensite:= 20 to p_taille- 1 do
                  (*$r-*)
                  with palPalEntry[l_intensite] do
                  (*$r+*)
                  begin
                    peGreen:= l_intensite;
                    peBlue:= l_intensite;
                  end; (* for, with *)
              end; (* with l_pt_info_palette_logique^ *)
            end; (* remplis_eau *)

          begin (* cree_palette *)
            (* -- alloue la place pour les informations de notre palette logique *)
            GetMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

            (* -- remplis les informations de notre palette logique *)
            l_pt_info_palette_logique^.palVersion:= $300;

            case p_type_palette of
              'A', 'B' : remplis_4_couleurs;
              'J' : remplis_jaunes;
              'V' : remplis_violets;
              'E' : remplis_vert_eau;
              'R' : remplis_rouge;
              else MessageBeep(0);
            end;

            (* -- cre notre palette logique *)
            pv_poignee_palette:= CreatePalette(l_pt_info_palette_logique^);

            (* -- La palette est cre. Peut rendre la mmoire des informations *)
            FreeMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));
          end; (* cree_palette *)

        var l_poignee_contexte_ecran: hDC;
            l_poignee_palette, l_poignee_palette_precedente: hPalette;
            l_poignee_brosse_indice, l_poignee_brosse_couleur: hBrush;

        type t_mode= (e_indice_palette, e_palette_rgb, e_rgb);

        procedure affiche_image_rouge(p_y: Word; p_couleur: t_mode);
          var l_indice: Word;
              l_poignee_brosse: hBrush;
              l_rectangle: tRect;
          begin
            for l_indice:= 0 to 256- 1 do
            begin
              case p_couleur of
                e_indice_palette : l_poignee_brosse:= CreateSolidBrush($01000000+ l_indice);
                e_palette_rgb : l_poignee_brosse:= CreateSolidBrush($02000000+ l_indice);
                e_rgb : l_poignee_brosse:= CreateSolidBrush(l_indice);
              end; (* case *)

              SetRect(l_rectangle, l_indice* 3, p_y, (l_indice+ 1)* 3, p_y+ 25);
              FillRect(l_poignee_contexte_ecran, l_rectangle, l_poignee_brosse);
              DeleteObject(l_poignee_brosse);
            end; (* for l_indice *)
          end; (* affiche_image_rouge *)

        begin (* modifie_palette *)
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          affiche_contexte_y(l_poignee_contexte_ecran, 102, 'affiche 0..255 par 3 mthodes');
          affiche_image_rouge(125, e_indice_palette);
          affiche_image_rouge(150, e_palette_rgb);
          affiche_image_rouge(175, e_rgb);

          affiche_contexte_y(l_poignee_contexte_ecran, 202, 'modifie la palette');
          cree_palette(l_poignee_palette);

          (* -- place notre palette logique dans le contexte *)
          l_poignee_palette_precedente:=
              SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
          (* -- ajuste la palette systme en utilisant notre palette du contexte *)
          RealizePalette(l_poignee_contexte_ecran);

          affiche_palette(l_poignee_contexte_ecran, 225, p_taille);

          affiche_contexte_y(l_poignee_contexte_ecran, 252, 'r-affiche 0..255 par 3 mthodes');
          affiche_image_rouge(275, e_indice_palette);
          affiche_image_rouge(300, e_palette_rgb);
          affiche_image_rouge(325, e_rgb);

          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, False);
          DeleteObject(l_poignee_palette);

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* modifie_palette *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'C' : affiche_capacites;
          'S' : affiche_palette_systeme;
          'D' : affiche_palette_par_defaut;

          '3' : modifie_palette(236, 'A');
          '1' : modifie_palette(64, 'B');
          'R' : modifie_palette(236, 'R');
          'J' : modifie_palette(128, 'J');
          'V' : modifie_palette(256, 'V');
          'E' : modifie_palette(256, 'E');
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);

        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(LtGray_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- paramtre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

