(* 002 palette2 *)
(* 09 sep 94 *)

(*$r+ *)
program illustre_palette;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe palette_2';
        k_titre_fenetre= 'palettes: Rouge, Bleue';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  type t_image= Array[0..191] of tPaletteEntry;
  var g_image_rouge, g_image_bleue: t_image;
      g_poignee_palette_rouge, g_poignee_palette_bleue: hPalette;
      g_palette_avant_plan: Char;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
        (* -- p_pt_create_structure (p_l_param) pointe vers une structure CREATESTRUCT *)

      procedure cree_palette(var pv_poignee_palette: hPalette; p_couleur: Char);
        var l_pt_info_palette_logique: ^tLogPalette;

        procedure remplis_info;
          var l_intensite: Integer;
          begin
            with l_pt_info_palette_logique^ do
            begin
              palNumEntries:= 192;
              FillChar(palPalEntry, palNumEntries* SizeOf(tPaletteEntry), 0);

              for l_intensite:= 191 downto 0 do
                (*$r-*)
                with palPalEntry[191- l_intensite] do
                (*$r+*)
                  if p_couleur= 'R'
                    then peRed:= round((4* l_intensite) / 3)
                    else peBlue:= round((4* l_intensite) / 3);
            end; (* with l_pt_info_palette_logique^ *)
          end; (* remplis_info *)

        begin (* cree_palette *)
          (* -- alloue la place pour les informations de notre palette logique *)
          GetMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

          (* -- remplis les informations de notre palette logique *)
          l_pt_info_palette_logique^.palVersion:= $300;

          remplis_info;

          (* -- cre notre palette logique *)
          pv_poignee_palette:= CreatePalette(l_pt_info_palette_logique^);

          (* -- La palette est cre. Peut rendre la mmoire des informations *)
          FreeMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));
        end; (* cree_palette *)

      var l_indice: Integer;

      begin (* traite_wm_create *)
        FillChar(g_image_rouge, SizeOf(g_image_rouge), 0);
        for l_indice:= 0 to 191 do
          g_image_rouge[l_indice].peRed:= round((4* l_indice) / 3);
        cree_palette(g_poignee_palette_rouge, 'R');

        FillChar(g_image_bleue, SizeOf(g_image_bleue), 0);
        for l_indice:= 0 to 191 do
          g_image_bleue[l_indice].peBlue:= round((4* l_indice) / 3);
        cree_palette(g_poignee_palette_bleue, 'B');

        g_palette_avant_plan:= ' ';
      end; (* traite_wm_create *)

    procedure affiche_contexte_y(p_poignee_contexte_ecran: hDC; p_y: Word; p_message: String);
      begin
        TextOut(p_poignee_contexte_ecran, 0, p_y, @p_message[1], length(p_message));
      end; (* affiche *)

    procedure affiche_image_rouge(p_poignee_contexte_ecran: hDC; p_y: Word);
      var l_indice: Word;
          l_poignee_brosse: hBrush;
          l_rectangle: tRect;
      begin
        for l_indice:= 0 to 191 do
        begin
          with g_image_rouge[l_indice] do
            l_poignee_brosse:= CreateSolidBrush($02000000
                + peRed+ peGreen shl 8 + peBlue shl 16);
          SetRect(l_rectangle, l_indice* 3, p_y, (l_indice+ 1)* 3, p_y+ 25);
          FillRect(p_poignee_contexte_ecran, l_rectangle, l_poignee_brosse);
          DeleteObject(l_poignee_brosse);
        end;
      end; (* affiche_image_rouge *)

    procedure affiche_image_bleue(p_poignee_contexte_ecran: hDC; p_y: Word);
      var l_indice: Word;
          l_poignee_brosse: hBrush;
          l_rectangle: tRect;
          l_couleur: LongInt;
      begin
        for l_indice:= 0 to 191 do
        begin
          with g_image_bleue[l_indice] do
          begin
            l_couleur:= peBlue;
            l_poignee_brosse:= CreateSolidBrush($02000000+ l_couleur shl 16);
          end;
          SetRect(l_rectangle, l_indice* 3, p_y+ 25, (l_indice+ 1)* 3, p_y+ 50);
          FillRect(p_poignee_contexte_ecran, l_rectangle, l_poignee_brosse);
          DeleteObject(l_poignee_brosse);
        end; (* for l_indice *)
      end; (* affiche_image_bleue *)

    procedure affiche_palette_systeme;
      (* -- cre une palette logique et la colorie avec les couleurs de la palette systme *)
      var l_poignee_contexte_ecran: hDC;
          l_pt_info_palette_logique: ^tLogPalette;
          l_indice: Integer;

          l_poignee_palette, l_poignee_palette_precedente: hPalette;
          l_poignee_brosse_indice, l_poignee_brosse_couleur: hBrush;
          l_rectangle: tRect;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        (* -- alloue la place pour les informations de la palette logique *)
        GetMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

        (* -- remplis les informations de la palette logique *)
        with l_pt_info_palette_logique^ do
        begin
          palVersion:= $300;
          palNumEntries:= 256;
          for l_indice:= 0 to 255 do
            (*$r-*)
            with palPalEntry[l_indice] do
            (*$r+*)
            begin
              (* -- indique que la valeur peRed est un indice dans la palette systme *)
              peFlags:= pc_Explicit;
              peRed:= l_indice;
              (* -- inutilis *)
              peGreen:= 0; peBlue:= 0;
            end;
        end;

        (* -- cre la palette logique *)
        l_poignee_palette:= CreatePalette(l_pt_info_palette_logique^);

        (* -- place la palette logique dans le contexte *)
        l_poignee_palette_precedente:=
            SelectPalette(l_poignee_contexte_ecran, l_poignee_palette, False);
        (* -- ajuste la palette systme en utilisant la palette du contexte *)
        RealizePalette(l_poignee_contexte_ecran);

        (* -- affiche le rsultat *)
        for l_indice:= 0 to 255 do
        begin
          (* -- couleur via PaletteIndex(indice) *)
          l_poignee_brosse_indice:= CreateSolidBrush(PaletteIndex(l_indice));
          SetRect(l_rectangle, l_indice* 3, 0, (l_indice+ 1)* 3, 25);
          FillRect(l_poignee_contexte_ecran, l_rectangle, l_poignee_brosse_indice);
          DeleteObject(l_poignee_brosse_indice);
        end; (* for *)

        (* -- dslectionne avant de dtruire *)
        SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, False);
        (* -- supprime notre palette *)
        DeleteObject(l_poignee_palette);

        (* -- rend la mmoire des informations de palette *)
        FreeMem(l_pt_info_palette_logique, Sizeof(tLogPalette)+ 255* Sizeof(tPaletteEntry));

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* affiche_palette_systeme *)

    procedure traite_wm_paint;
      var l_structure_dessin: tPaintStruct;
          l_poignee_contexte_ecran: hDC;

      begin (* traite_mwPaint *)
        l_poignee_contexte_ecran:= BeginPaint(p_poignee_fenetre, l_structure_dessin);

        affiche_palette_systeme;
        affiche_contexte_y(l_poignee_contexte_ecran, 27, 'images avec palette par dfaut');
        affiche_image_rouge(l_poignee_contexte_ecran, 50);
        affiche_image_bleue(l_poignee_contexte_ecran, 50);

        EndPaint(p_poignee_fenetre, l_structure_dessin);
      end; (* traite_wmPaint *)

    procedure affiche_palette(p_poignee_contexte_ecran: hDC; p_y, p_taille: Word);
      var l_indice: Word;
          l_poignee_brosse: hBrush;
          l_rectangle, l_rectangle_client: tRect;
      begin
        for l_indice:= 0 to p_taille- 1 do
        begin
          l_poignee_brosse:= CreateSolidBrush($01000000+ l_indice);
          SetRect(l_rectangle, l_indice* 3, p_y, (l_indice+ 1)* 3, p_y+ 25);
          FillRect(p_poignee_contexte_ecran, l_rectangle, l_poignee_brosse);
          DeleteObject(l_poignee_brosse);
        end; (* for l_indice *)

        GetClientRect(p_poignee_fenetre, l_rectangle_client);
        SetRect(l_rectangle, p_taille* 3, p_y, l_rectangle_client.Right, p_y+ 25);
        FillRect(p_poignee_contexte_ecran, l_rectangle, GetStockObject(LtGray_Brush));
      end; (* affiche_palette *)

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure modifie_palette(p_type_palette: Char);
        var l_poignee_contexte_ecran: hDC;
            l_poignee_palette_precedente: hPalette;
        begin (* modifie_palette *)
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          g_palette_avant_plan:= p_type_palette;

          case Upcase(p_type_palette) of
            'R' : begin
                    affiche_contexte_y(l_poignee_contexte_ecran, 102, 'Paltte 192 rouges avant-plan  ');

                    (* -- place notre palette logique dans le contexte *)
                    l_poignee_palette_precedente:=
                        SelectPalette(l_poignee_contexte_ecran, g_poignee_palette_rouge, False);

                    (* -- ajuste la palette systme en utilisant notre palette du contexte *)
                    RealizePalette(l_poignee_contexte_ecran);
                    affiche_palette(l_poignee_contexte_ecran, 125, 192);

                    affiche_contexte_y(l_poignee_contexte_ecran, 152,
                        '  Images avec palette avant plan');
                    affiche_image_rouge(l_poignee_contexte_ecran, 175);

                    SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Pen));
                    MoveTo(l_poignee_contexte_ecran, 0, 175+ 25);
                    LineTo(l_poignee_contexte_ecran, 3* 192, 175+ 49);
                  end;
            'B' : begin
                    affiche_contexte_y(l_poignee_contexte_ecran, 102, 'Palette 192 bleus avant-plan  ');

                    (* -- place notre palette logique dans le contexte *)
                    l_poignee_palette_precedente:=
                      SelectPalette(l_poignee_contexte_ecran, g_poignee_palette_bleue, False);

                    (* -- ajuste la palette systme en utilisant notre palette du contexte *)
                    RealizePalette(l_poignee_contexte_ecran);

                    affiche_palette(l_poignee_contexte_ecran, 125, 192);

                    affiche_contexte_y(l_poignee_contexte_ecran, 152,
                        '  Images avec palette avant plan');
                    affiche_image_bleue(l_poignee_contexte_ecran, 175);

                    SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Pen));
                    MoveTo(l_poignee_contexte_ecran, 0, 175);
                    LineTo(l_poignee_contexte_ecran, 3* 192, 175+ 24);
                  end;
          end; (* case *)

          SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, False);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* modifie_palette *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'R' : modifie_palette('R');
          'B' : modifie_palette('B');
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_palette_changed;
      var l_poignee_contexte_ecran: hDC;
          l_poignee_palette_precedente: hPalette;
      begin (* modifie_palette *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        case g_palette_avant_plan of
          'R' : begin
                  affiche_contexte_y(l_poignee_contexte_ecran, 230, 'Palette 192 bleus arrire-plan    ');
                  l_poignee_palette_precedente:= SelectPalette(l_poignee_contexte_ecran,
                      g_poignee_palette_bleue, True);

                  g_palette_avant_plan:= ' ';
                  RealizePalette(l_poignee_contexte_ecran);

                  affiche_palette(l_poignee_contexte_ecran, 255, 192);

                  affiche_contexte_y(l_poignee_contexte_ecran, 282, '  Bleu corrig     ');
                  affiche_image_bleue(l_poignee_contexte_ecran, 305- 25);
                end;
          'B' : begin
                  affiche_contexte_y(l_poignee_contexte_ecran, 230, 'Palette 192 rouges arrire-plan');
                  l_poignee_palette_precedente:= SelectPalette(l_poignee_contexte_ecran,
                      g_poignee_palette_rouge, True);

                  g_palette_avant_plan:= ' ';
                  RealizePalette(l_poignee_contexte_ecran);

                  affiche_palette(l_poignee_contexte_ecran, 255, 192);

                  affiche_contexte_y(l_poignee_contexte_ecran, 282, '  Rouge corrig  ');
                  affiche_image_rouge(l_poignee_contexte_ecran, 305);
                end;
        end; (* case *)

        SelectPalette(l_poignee_contexte_ecran, l_poignee_palette_precedente, False);
        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_palette_changed *)

    procedure traite_wm_mouse_move(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      var l_poignee_contexte_ecran: hDC;
          l_couleur: LongInt;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
        l_couleur:= GetPixel(l_poignee_contexte_ecran, p_x, p_y);
        affiche_contexte_y(l_poignee_contexte_ecran, 340,
            'Couleur souris: r= '+ f_mot_chaine(l_couleur and $FF)
            + ', v= '+ f_mot_chaine( (l_couleur shr 8) and $FF)
            + ', b= '+ f_mot_chaine( (l_couleur shr 16) and $FF)+ '            ');
        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_mouse_move *)

    procedure traite_wm_destroy;
      begin
        DeleteObject(g_poignee_palette_rouge);
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create: traite_wm_create(pCreateStruct(p_l_param));
        wm_Paint: traite_wm_paint;
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_PaletteChanged: traite_wm_palette_changed;
        wm_MouseMove: traite_wm_mouse_move(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);

        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(LtGray_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
