(* 002 polygone *)
(* 15 sep 94 *)

(*$r+ *)
program illustre_figures_pleines;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe figures pleines 2';
        k_titre_fenetre= 'RoundRect, polygone: Alternate Winding';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  const k_nombre_max= 500;
        gi_nombre: Word= 0;
        gi_a_affiche: Boolean= True;
  var g_table_points: array[0..k_nombre_max- 1] of tPoint;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      var l_poignee_contexte_ecran: hDC;

      procedure dessine_rectangles_arrondis;
        var l_poignee_crayon: hPen;
        begin (* dessine_rectangles *)
          (* -- crayon par dfaut reste de 1 pixels, mme si pass en mode anisotropique *)
          RoundRect(l_poignee_contexte_ecran, 10, 10, 210, 110, 60, 40);

          l_poignee_crayon:= CreatePen(ps_Dot, 1, $000000FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
          SetBkMode(l_poignee_contexte_ecran, Transparent);
          Ellipse(l_poignee_contexte_ecran, 10, 10, 10+ 60, 10+ 40);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);
        end; (* dessine_rectangles *)

      procedure dessine_polygone(p_alternate_winding: String);
        var l_poignee_contexte_ecran: hDC;
            l_poignee_brosse: hBrush;
        begin
          if gi_nombre> 0
            then begin
                l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

                l_poignee_brosse:= CreateSolidBrush($000000FF);
                SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);

                if p_alternate_winding= 'Alternate'
                  then SetPolyFillMode(l_poignee_contexte_ecran, Alternate)
                  else SetPolyFillMode(l_poignee_contexte_ecran, Winding);
                Polygon(l_poignee_contexte_ecran, g_table_points, gi_nombre);

                SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
                DeleteObject(l_poignee_brosse);

                gi_a_affiche:= true;
                ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
              end;
        end; (* dessine_polygone *)

      begin (* traite_wm_char *)
        InvalidateRect(p_poignee_fenetre, nil, true);
        UpdateWindow(p_poignee_fenetre);

        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        case UpCase(p_caractere) of
          'R' : dessine_rectangles_arrondis;
          'A' : dessine_polygone('Alternate');
          'W' : dessine_polygone('Winding');
        end; (* case *)

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_char *)

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      var l_poignee_contexte_ecran: hDC;
      begin
        if gi_a_affiche
          then begin
              gi_nombre:= 0;
              gi_a_affiche:= false;
            end;

        if gi_nombre< k_nombre_max
          then begin
              if gi_nombre> 0
                then begin
                    l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
                    with g_table_points[gi_nombre- 1] do
                      MoveTo(l_poignee_contexte_ecran, x, y);
                    LineTo(l_poignee_contexte_ecran, p_x, p_y);
                    ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
                  end;

              g_table_points[gi_nombre].x:= p_x; g_table_points[gi_nombre].y:= p_y;
              inc(gi_nombre);
            end;
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_r_button_down(p_bouton_ou_touche: Word; p_x, p_y: integer);
      var l_poignee_contexte_ecran: hDC;
          l_poignee_brosse: hBrush;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        (* -- la brosse pour remplir *)
        l_poignee_brosse:= CreateSolidBrush($0000FF00);
        SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);

        (* -- remplis la figure dlimite par des pixels de couleur $00000000 (noir) *)
        FloodFill(l_poignee_contexte_ecran, p_x, p_y, $00000000);

        SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
        DeleteObject(l_poignee_brosse);

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_r_button_down *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_rButtonDown: traite_wm_r_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

