(* 002 region *)
(* 02 aou 94 *)

(*$r+ *)
program illustre_region;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  type t_long_word= record
                      lo, hi: word;
                    end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe region';
        k_titre_fenetre= 'Region, Clippe';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_largeur_client: Word= 0;
          ls_hauteur_client: Word= 0;
          ls_poignee_region_resultat: hRgn= 0;

    procedure traite_wm_size(p_w_param: Word; p_largeur, p_hauteur: integer);
        (* -- p_w_param est le type de changement de taille *)
        (* -- p_cx (p_l_param.Lo) est la nouvelle largeur *)
        (* -- p_cy (p_l_param.Hi) est la nouvelle hauteur *)
      begin
        ls_largeur_client:= p_largeur;
        ls_hauteur_client:= p_hauteur;
        if ls_poignee_region_resultat= 0
          then ls_poignee_region_resultat:= CreateRectRgn(0, 0, 0, 0);
      end; (* traite_wm_size *)

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure remplis_region;
        const k_sommets= 6;
              k_table_points: array[0..k_sommets- 1] of tPoint
                  = ((x: 50; y: 40), (x:150; y: 40), (x: 80; y: 100),
                     (x:20; y: 60), (x:180; y: 60), (x:120; y:100));
        var l_poignee_region_polygonale: hRgn;
            l_poignee_region_elliptique: hRgn;
            l_poignee_contexte_ecran: hDC;
            l_poignee_brosse: hBrush;
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
          l_poignee_brosse:= CreateSolidBrush($000000FF);

          l_poignee_region_polygonale:= CreatePolygonRgn(k_table_points, k_sommets, Alternate);
          FillRgn(l_poignee_contexte_ecran, l_poignee_region_polygonale, l_poignee_brosse);

          DeleteObject(l_poignee_brosse);
          l_poignee_brosse:= CreateSolidBrush($0000FF00);

          l_poignee_region_elliptique:= CreateEllipticRgn(10, 65, 190, 165);
          FrameRgn(l_poignee_contexte_ecran, l_poignee_region_elliptique, l_poignee_brosse, 2, 2);

          OffsetRgn(l_poignee_region_polygonale, 190, 0);
          OffsetRgn(l_poignee_region_elliptique, 190, 0);
          CombineRgn(ls_poignee_region_resultat, l_poignee_region_elliptique,
              l_poignee_region_polygonale, rgn_Diff);
          FillRgn(l_poignee_contexte_ecran, ls_poignee_region_resultat, l_poignee_brosse);

          DeleteObject(l_poignee_brosse);
          DeleteObject(l_poignee_region_polygonale);
          DeleteObject(l_poignee_region_elliptique);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* remplis_region *)

      procedure clippe_region;
        var l_poignee_contexte_ecran: hDC;
            l_poignee_crayon: hPen;
            l_angle: Word;
        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          SelectClipRgn(l_poignee_contexte_ecran, ls_poignee_region_resultat);

          l_poignee_crayon:= CreatePen(ps_Solid, 1, $000000FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);

          SetViewportOrg(l_poignee_contexte_ecran, 10+ 190, 130);

          For l_angle:= 0 to 360 do
          begin
            MoveTo(l_poignee_contexte_ecran, 0, 0);
            Lineto(l_poignee_contexte_ecran, round( 200* cos(4* pi* l_angle/ 360)),
                  round( 200* sin(4* pi* l_angle/ 360)));
          end;

          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* clippe_region *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'C' : clippe_region;
          'R' : remplis_region;
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        DeleteObject(ls_poignee_region_resultat);
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Size: traite_wm_size(p_w_param, t_long_word(p_l_param).lo, t_long_word(p_l_param).hi);
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

