(* 002 rop2 *)
(* 06 sep 94 *)

(*$r+ *)
program illustre_codes_rop_2;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe rop2';
        k_titre_fenetre= 'illustre ROP2';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot: 3, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_Param: Word; p_l_Param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_paint;
      var l_structure_dessin: tPaintStruct;
          l_poignee_contexte_ecran: hDC;
          l_rectangle_client: tRect;

          l_rectangle: tRect;
          l_brosse_en_stock: hBrush;

          l_poignee_crayon_noir, l_poignee_crayon_blanc: hPen;
          l_rop_2: Word;
          l_code: String;
      begin (* traite_mwPaint *)
        l_poignee_contexte_ecran:= BeginPaint(p_poignee_fenetre, l_structure_dessin);

        GetClientRect(p_poignee_fenetre, l_rectangle_client);

        with l_rectangle_client do
        begin
          (* -- dessine 5 bandes horizontales avec les 5 brosses en stock *)
          SetMapMode(l_poignee_contexte_ecran, mm_AnIsotropic);
          SetViewportOrg(l_poignee_contexte_ecran, 10, 40);
          SetViewPortExt(l_poignee_contexte_ecran, Right- 20, Bottom- Top- 60);
          SetWindowExt(l_poignee_contexte_ecran, 1, 5);

          for l_brosse_en_stock:= 0 to 4 do
          begin
            SelectObject(l_poignee_contexte_ecran, GetStockObject(l_brosse_en_stock));
            Rectangle(l_poignee_contexte_ecran, 0, l_brosse_en_stock, 1, l_brosse_en_stock+ 1);
          end; (* for l_brosse_en_stock *)

          (* -- dessine 48 traits verticaux *)
          SetViewportOrg(l_poignee_contexte_ecran, 20+ (Right- 40) div (32*2), 30);
          SetViewPortExt(l_poignee_contexte_ecran, Right- 40, 1);
          SetWindowExt(l_poignee_contexte_ecran, 32, 1);

          l_poignee_crayon_noir:= CreatePen(ps_Solid, 1, $000000);
          l_poignee_crayon_blanc:= CreatePen(ps_Solid, 1, $FFFFFF);

          for l_rop_2:= 1 to 16 do
          begin
            Str(l_rop_2, l_code);
            TextOut(l_poignee_contexte_ecran, (l_rop_2- 1)* 2, -30, @l_code[1], Length(l_code));

            SetROP2(l_poignee_contexte_ecran, l_rop_2);

            SelectObject(l_poignee_contexte_ecran, l_poignee_crayon_noir);
            MoveTo(l_poignee_contexte_ecran, (l_rop_2- 1)* 2, 0);
            LineTo(l_poignee_contexte_ecran, (l_rop_2- 1)* 2, Bottom- 45);

            SelectObject(l_poignee_contexte_ecran, l_poignee_crayon_blanc);
            MoveTo(l_poignee_contexte_ecran, (l_rop_2- 1)* 2+ 1, 0);
            LineTo(l_poignee_contexte_ecran, (l_rop_2- 1)* 2+ 1, Bottom- 45);
          end; (* for l_rop_2 *)

          DeleteObject(l_poignee_crayon_noir);
          DeleteObject(l_poignee_crayon_blanc);
        end; (* with l_rectangle *)

        EndPaint(p_poignee_fenetre, l_structure_dessin);
      end; (* traite_wmPaint *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Paint: traite_wm_paint;
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de recuperation et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

