(* 002 scrollwi *)
(* 02 aou 94 *)

(*$r+ *)
program illustre_scroll_window;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;
       t_long_mot= record
                     lo, hi: Word;
                   end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe scrollwindow';
        k_titre_fenetre= 'affiche les messages';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  const k_indice_message_max= 1000;
  type t_message= record
                    code: Word;
                  end;
  const gi_indice_message_suivant: Integer= 0;
  var g_tableau_messages: array[0..k_indice_message_max- 1] of t_message;

  procedure affiche_entier(p_poignee_contexte_peripherique: hDC;
      p_x, p_y: integer;
      p_entier: integer; p_taille: integer);
    var l_chaine: string;
        l_justification_precedente: Word;
        l_taille_caractere: Word;
    begin
      str(p_entier, l_chaine);

      l_taille_caractere:= LoWord(GetTextExtent(p_poignee_contexte_peripherique, '0', 1));

      l_justification_precedente:= SetTextAlign(p_poignee_contexte_peripherique, ta_Right);
      TextOut(p_poignee_contexte_peripherique, p_x+ l_taille_caractere* p_taille, p_y,
          @l_chaine[1], Length(l_chaine));
      SetTextAlign(p_poignee_contexte_peripherique, l_justification_precedente);
    end; (* affiche_entier *)

  function f_nom_message(p_code: Word): String;
    begin
      case p_code of
           1 : f_nom_message:= 'wm_Create';
           3 : f_nom_message:= 'wm_Move';
           5 : f_nom_message:= 'wm_Size';
          15 : f_nom_message:= 'wm_Paint';
          20 : f_nom_message:= 'wm_EraseBackground';
          24 : f_nom_message:= 'wm_ShowWindow';
         513 : f_nom_message:= 'wm_lButtonDown';
         514 : f_nom_message:= 'wm_lButtonUp';
         516 : f_nom_message:= 'wm_rButtonDown';
         517 : f_nom_message:= 'wm_rButtonUp';

        else f_nom_message:= '?';
      end; (* case p_code *)
    end; (* f_nom_message *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_largeur_client: Word= 0;
          ls_hauteur_client: Word= 0;

          ls_largeur_caractere: Integer= 0;
          ls_hauteur_caractere: Integer= 0;

          ls_indice_message_bas: Word= 0;

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
      var l_poignee_contexte_ecran: hDC;
          l_metrique: tTextMetric;
      begin (* traite_wm_create *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
        GetTextMetrics(l_poignee_contexte_ecran, l_metrique);
        with l_metrique do
        begin
          ls_largeur_caractere:= tmAveCharWidth;
          ls_hauteur_caractere:= tmHeight;
        end; (* with l_metrique *)

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_create *)

    procedure traite_wm_size(p_w_param: Word; p_largeur_client, p_hauteur_client: Word);
        (* -- wParam est le type de changement de taille *)
        (* -- p_cx (lParam.Lo) est la nouvelle largeur *)
        (* -- p_cy (lParam.Hi) est la nouvelle hauteur *)
      begin
        ls_largeur_client:= p_largeur_client;
        ls_hauteur_client:= p_hauteur_client;
      end; (* traite_wm_size *)

    procedure affiche_un_message(p_poignee_contexte_ecran: hDC; p_y: Word; p_indice: Word);
      var l_nom_message: String;
      begin
        with g_tableau_messages[p_indice] do
        begin
          l_nom_message:= f_nom_message(code);
          affiche_entier(p_poignee_contexte_ecran, 0, p_y, p_indice, 5);
          affiche_entier(p_poignee_contexte_ecran, 5* ls_largeur_caractere, p_y,
                    code, 5);
          l_nom_message:= f_nom_message(code);
          TextOut(p_poignee_contexte_ecran, 11* ls_largeur_caractere, p_y,
              @l_nom_message[1], Length(l_nom_message));
        end;
      end; (* affiche_un_message *)

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word;
           p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
      var l_derniere_ligne, l_indice_dernier: Word;
          l_poignee_contexte_ecran: hDC;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
        (* -- n'affiche que le dernier message *)
        l_derniere_ligne:= ls_hauteur_client div ls_hauteur_caractere- 1;

        ScrollWindow(p_poignee_fenetre, 0, -ls_hauteur_caractere, Nil, Nil);

        (* -- efface le fond du rectangle dcouvert par ScrollWindow *)
        UpdateWindow(p_poignee_fenetre);
        SetBkColor(l_poignee_contexte_ecran, $00FFFF00);
        affiche_un_message(l_poignee_contexte_ecran, l_derniere_ligne* ls_hauteur_caractere,
            ls_indice_message_bas);
        (* -- affiche le message suivant *)
        inc(ls_indice_message_bas);

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_r_button_down(p_bouton_ou_touche: Word;
          p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
      var l_poignee_contexte_ecran: hDC;
          l_indice_premier_message: Integer;
          l_rectangle_defile: tRect;
      begin
        (* -- l'indice du message au dbut de la fentre *)
        l_indice_premier_message:= ls_indice_message_bas
            - ls_hauteur_client div ls_hauteur_caractere- 1;

        if l_indice_premier_message>= 0
          then begin
              l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

              (* -- ne dfiler que des lignes entires *)
              With l_rectangle_defile do
              begin
                Left:= 0; Top:= 0; Right:= ls_largeur_client;
                Bottom:= (ls_hauteur_client div ls_hauteur_caractere- 1)
                    * ls_hauteur_caractere;
              end;

              ScrollWindow(p_poignee_fenetre, 0, ls_hauteur_caractere, @l_rectangle_defile, Nil);
              (* -- efface le fond du rectangle dcouvert par ScrollWindow *)
              UpdateWindow(p_poignee_fenetre);

              (* -- recule *)
              dec(ls_indice_message_bas);
              SetBkColor(l_poignee_contexte_ecran, $00FF00FF);
              affiche_un_message(l_poignee_contexte_ecran, 0,
                  l_indice_premier_message);

              ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
            end;
      end; (* traite_wm_r_button_down *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      (* -- n'enregistre que les messages que nous avons choisis *)
      if (f_nom_message(p_code_message)<> '?')
          and (gi_indice_message_suivant< k_indice_message_max)
        then begin
            g_tableau_messages[gi_indice_message_suivant].code:= p_code_message;
            inc(gi_indice_message_suivant);
          end;

      case p_code_message of
        wm_Create : traite_wm_create(Pointer(p_l_param));
        wm_Size: traite_wm_size(p_w_param, t_long_mot(p_l_param).lo, t_long_mot(p_l_param).hi);
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_rButtonDown: traite_wm_r_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          100, 100, 600, 200,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de recuperation et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
