(* 002 sourcla3 *)
(* 02 aou 94 *)

(*$r+ *)
program simule_la_souris_avec_le_clavier;
  uses WinTypes, WinProcs, Strings;

  type t_long_word= record
                      lo, hi: Word;
                    end;
       t_long_integer= record
                         lo, hi: Integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe souris clavier';
        k_titre_fenetre= 'simule souris avec clavier';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  const k_nombre_couleurs= 7;
  type t_dessin= record
                   le_rectangle, cadre: tRect;
                   couleur: LongInt;
                 end;
  var g_table_couleurs: array[0..k_nombre_couleurs- 1] of t_dessin;
      g_couleur_selectionnee: Integer;

      g_table_ventes: Array[1..12] of t_dessin;
      g_mois_selectionne: Integer;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_Param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_largeur_client: Word= 0;
          ls_hauteur_client: Word= 0;

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
        (* -- p_pt_create_structure (p_L_param) pointe vers une structure CREATESTRUCT *)
      var l_couleur: Word;
          l_rouge, l_vert, l_bleu: Word;
          l_mois: Word;
      begin
        g_couleur_selectionnee:= 0;
        g_mois_selectionne:= 1;

        (* -- initialise les couleurs *)
        for l_couleur:= 0 to k_nombre_couleurs- 1 do
          with g_table_couleurs[l_couleur] do
          begin
            l_rouge:= l_couleur and $01; l_vert:= (l_couleur and $02) shr 1;
            l_bleu:= (l_couleur and $04) shr 2;
            couleur:= l_rouge* $000000FF+ l_vert* $0000FF00+ l_bleu* $0FF0000;
          end;

        for l_mois:= 1 to 12 do
          g_table_ventes[l_mois].couleur:= $000000FF;
      end; (* traite_wm_create *)

    procedure affiche_curseur(p_mois: Integer);
      var l_point_curseur: tPoint;
      begin
        if p_mois> 0
          then
            with g_table_ventes[p_mois].le_rectangle, l_point_curseur do
            begin
              x:= (Left+ Right) div 2;
              y:= (Top+ Bottom) div 2;
              ClientToScreen(p_poignee_fenetre, l_point_curseur);
              SetCursorPos( x, y );
            end;
      end; (* affiche_curseur *)

    procedure traite_wm_size(p_w_param: Word; p_largeur, p_hauteur: integer);
        (* -- p_w_param est le type de changement de taille *)
        (* -- p_cx (p_l_param.Lo) est la nouvelle largeur *)
        (* -- p_cy (p_l_param.Hi) est la nouvelle hauteur *)
      var l_hauteur_couleur, l_couleur: Word;
          l_mois: Word;
      begin
        ls_largeur_client:= p_largeur;
        ls_hauteur_client:= p_hauteur;

        (* -- cre la table des 7 couleurs *)
        l_hauteur_couleur:= p_hauteur div (k_nombre_couleurs+ 2);

        for l_couleur:= 0 to k_nombre_couleurs- 1 do
          with g_table_couleurs[l_couleur], le_rectangle do
          begin
            Left:= p_largeur div 27;
            Top:= (l_couleur+ 1)* (l_hauteur_couleur+ 2);
            Right:= Left+ p_largeur div 27;
            Bottom:= Top+ l_hauteur_couleur- 2;
            cadre.Left:= Left- 2; cadre.Right:= Right+ 2; cadre.top:= top- 2; cadre.bottom:= bottom+ 2;
          end;

        (* -- cre la table des 12 ventes *)
        for l_mois:= 1 to 12 do
          with g_table_ventes[l_mois], le_rectangle do
          begin
            Left:= p_largeur div 3+ (l_mois- 1)* (p_largeur div 36);
            Top:= p_hauteur div 3+ (p_hauteur div 9- random(2* p_hauteur div 9));
            Right:= Left+ p_largeur div 36- 1;
            Bottom:= 2* p_hauteur div 3;
          end;

        affiche_curseur(g_mois_selectionne);
      end; (* traite_wm_size *)

    procedure traite_wm_paint;
      var l_structure_dessin: tPaintStruct;
          l_poignee_contexte_ecran: hDC;
          l_mois: Word;
          l_poignee_brosse: hBrush;
          l_couleur: Word;
      begin (* traite_mwPaint *)
        l_poignee_contexte_ecran:= BeginPaint(p_poignee_fenetre, l_structure_dessin);

        if g_couleur_selectionnee<> -1
          then InvertRect(l_poignee_contexte_ecran, g_table_couleurs[g_couleur_selectionnee].cadre);

        for l_couleur:= 0 to k_nombre_couleurs- 1 do
          with g_table_couleurs[l_couleur] do
          begin
            l_poignee_brosse:= CreateSolidBrush(couleur);
            FillRect(l_poignee_contexte_ecran, le_rectangle, l_poignee_brosse);
            DeleteObject(l_poignee_brosse);
          end;

        for l_mois:= 1 to 12 do
          with g_table_ventes[l_mois] do
          begin
            l_poignee_brosse:= CreateSolidBrush(couleur);
            FillRect(l_poignee_contexte_ecran, le_rectangle, l_poignee_brosse);
            DeleteObject(l_poignee_brosse);
          end;

        EndPaint(p_poignee_fenetre, l_structure_dessin);
      end; (* traite_wmPaint *)

     procedure traite_wm_l_button_down(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'absisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      var l_mois: Word;
          l_poignee_contexte_ecran: hDC;
          l_couleur: Integer;
      begin
        (* -- a cliqu sur une couleur ? *)
        for l_couleur:= 0 to k_nombre_couleurs- 1 do
          if PtInRect(g_table_couleurs[l_couleur].le_rectangle, tPoint(p_l_param))
            then begin
                g_couleur_selectionnee:= l_couleur;
                InvalidateRect(p_poignee_fenetre, nil, True);
                UpdateWindow(p_poignee_fenetre);
              end;

        (* -- a cliqu sur une vente ? *)
        if g_couleur_selectionnee<> -1
          then
            for l_mois:= 1 to 12 do
              if PtInRect(g_table_ventes[l_mois].le_rectangle, tPoint(p_l_param))
                then
                  with g_table_ventes[l_mois], le_rectangle do
                  begin
                    couleur:= g_table_couleurs[g_couleur_selectionnee].couleur;
                    InvalidateRect(p_poignee_fenetre, @le_rectangle, True);
                    UpdateWindow(p_poignee_fenetre);
                  end;
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_key_down(p_code_virtuel: Word; p_l_param: LongInt);
        (* --   p_code_virtuel est le code virtuel de la touche *)
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      var l_point: tPoint;
      begin
        case p_code_virtuel of
          (* -- slectionne le couleur *)
          vk_Down : begin
                      g_couleur_selectionnee:= (g_couleur_selectionnee+ 1) mod k_nombre_couleurs;
                      InvalidateRect(p_poignee_fenetre, nil, True);
                    end;
          vk_Up : begin
                    (* -- calcule, dans une locale, l'indice pour calculer la position *)
                    if g_couleur_selectionnee= 0
                      then g_couleur_selectionnee:= k_nombre_couleurs- 1
                      else g_couleur_selectionnee:= g_couleur_selectionnee- 1;

                    InvalidateRect(p_poignee_fenetre, nil, True);
                  end;

          (* -- slectionne le mois *)
          vk_Right : begin
                      g_mois_selectionne:= 1+ (g_mois_selectionne mod 12);
                      affiche_curseur(g_mois_selectionne);
                     end;
          vk_Left : begin
                      if g_mois_selectionne= 1
                        then g_mois_selectionne:= 12
                        else g_mois_selectionne:= g_mois_selectionne- 1;
                       affiche_curseur(g_mois_selectionne);
                    end;

          (* -- colorie le mois slectionn avec la couleur slectionne *)
          vk_Return : begin
                        GetCursorPos(l_point);
                        ScreenToClient(p_poignee_fenetre, l_point);
                        (* -- simule un clic souris *)
                        SendMessage(p_poignee_fenetre,
                            wm_lButtonDown, mk_lButton, LongInt(l_point));
                      end;
        end; (* case *)
      end; (* traite_wm_key_down *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create: traite_wm_create(pCreateStruct(p_l_param));
        wm_Size: traite_wm_size(p_w_param, t_long_word(p_l_param).lo, t_long_word(p_l_param).hi);
        wm_Paint: traite_wm_paint;

        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_KeyDown: traite_wm_key_down(p_w_param, p_l_param);

        wm_Destroy: traite_wm_destroy;

        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- paramtre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- demande la conversion des messages touches en messages caractres *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

