(* 002 tachfond *)
(* 02 aou 94 *)

(*$r+ *)
program traite_tache_de_fond;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe timer3';
        k_titre_fenetre= 'traite tache de fond';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

      g_poignee_fenetre: hWnd;

  procedure traite_horloge(p_poignee_fenetre: hWnd; p_code_message: word; p_w_param: word;
        p_l_param: longint); export;
    (* -- p_poignee_fenetre est 0, l'horloge a t cre par SetTimer(0, 0..) *)
    var l_poignee_contexte_ecran: hDC;
        l_rectangle: tRect;
    begin
      l_poignee_contexte_ecran:= GetDC(g_poignee_fenetre);

      (* -- fait clignoter un carr *)
      SetRect(l_rectangle, 10, 10, 20, 20);
      InvertRect(l_poignee_contexte_ecran, l_rectangle);

      ReleaseDC(g_poignee_fenetre, l_poignee_contexte_ecran);
    end; (* traite_horloge *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_identificateur_horloge: Word= 0;
          k_milisecondes= 500;
          ls_pt_procedure_horloge: tFarProc= nil;

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
        (* -- p_pt_create_structure (p_l_param) pointe vers une structure CREATESTRUCT *)
      begin
        ls_pt_procedure_horloge:= MakeProcInstance(@traite_horloge, g_instance);

        repeat
          ls_identificateur_horloge:= SetTimer(0, 0, k_milisecondes, ls_pt_procedure_horloge);
        until ls_identificateur_horloge<> 0;
      end; (* traite_wm_create *)

    procedure traite_wm_key_down(p_code_virtuel: Word; p_l_param: LongInt);
        (* --   p_code_virtuel est le code virtuel de la touche *)
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      const k_angle= 10;
      var l_angle: Word;
          l_poignee_contexte_ecran: hDC;
          l_message: tMsg;
          l_delai: Word;
      begin
        case p_code_virtuel of
          vk_Space : begin
                       l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

                       (* -- affichage un peu long *)
                       l_angle:= 1;
                       repeat
                         if PeekMessage(l_message, 0, 0, 0, pm_Remove)
                           then begin
                               if l_message.Message= wm_Quit
                                 then Halt(0);
                               TranslateMessage(l_message);
                               DispatchMessage(l_message);
                             end
                           else begin
                               for l_delai:= 1 to 150 do
                                 MessageBeep(0);
                               MoveTo(l_poignee_contexte_ecran, 100, 100);
                               Lineto(l_poignee_contexte_ecran,
                                 100+ round(100* cos(2* pi/360* l_angle)),
                                 100+ round(100* sin(2* pi/360* l_angle)));
                               inc(l_angle, k_angle);
                             end;
                       until l_angle> 360;

                       ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
                     end;
        end; (* case *)
      end; (* traite_wm_key_down *)

    procedure traite_wm_destroy;
      begin
        if ls_pt_procedure_horloge<> nil
          then FreeProcInstance(ls_pt_procedure_horloge);
        KillTimer(p_poignee_fenetre, ls_identificateur_horloge);

        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create: traite_wm_create(pCreateStruct(p_l_param));
        wm_KeyDown: traite_wm_key_down(p_w_param, p_l_param);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      g_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(g_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(g_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touches en messages caractres *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

