(* 002 textmetric *)
(* 02 aou 94 *)

(*$r+ *)
program affiche_textmetric;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe textmetric';
        k_titre_fenetre= 'affiche mtrique fonte';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_Allure_Initiale: Integer absolute CmdShow;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word;
          p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
      var l_poignee_contexte_ecran: hDC;
          l_points_horizontaux, l_points_verticaux: integer;
          l_ligne: integer;

      procedure affiche(p_explication: String; p_valeur: integer);
        var l_valeur: string;
        begin
          TextOut(l_poignee_contexte_ecran, 0, l_ligne, @p_explication[1], length(p_explication));

          if p_valeur<> -1
            then begin
                Str(p_valeur, l_valeur);
                TextOut(l_poignee_contexte_ecran, 29* l_points_horizontaux, l_ligne,
                    @l_valeur[1], length(l_valeur));
              end;

          l_ligne:= l_ligne+ l_points_verticaux;
        end; (* affiche *)

      var l_metrique_police: tTextMetric;

      begin (* traite_wm_l_button_down *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        (* -- rcupre les paramtres de la fonte du contexte *)
        GetTextMetrics(l_poignee_contexte_ecran, l_metrique_police);

        with l_metrique_police do
        begin
          (* -- rcupre les valeurs pour afficher correctement *)
          l_points_horizontaux:= tmAveCharWidth;
          l_points_verticaux:= tmHeight;

          l_ligne:= 0;

          affiche('hauteur', tmHeight);
          affiche('acent', tmAscent);
          affiche('descent', tmDescent);
          affiche('leading interne', tmInternalLeading);
          affiche('leading externe', tmExternalLeading);
          affiche('largeur moyenne', tmAveCharWidth);
          affiche('largeur max', tmMaxCharWidth);
          affiche('poids', tmWeight);
          affiche('italique', tmItalic);
          affiche('soulign', tmUnderlined);
          affiche('struck out', tmStruckOut);
          affiche('premier caractre', tmFirstChar);
          affiche('dernier caractre', tmLastChar);
          affiche('caractre hors intervalle', tmDefaultChar);
          affiche('caractre csure', tmBreakChar);

          if tmPitchAndFamily and $0F= 0
            then affiche('fonte fixe', -1)
            else affiche('fonte proportionnelle', -1);

          case tmPitchAndFamily and $F0 of
            ff_Decorative : affiche('dcorative', -1);
            ff_DontCare : affiche('s en fout', -1);
            ff_Modern : affiche('fixe, avec ou sans srifs', -1);
            ff_Roman : affiche('variable avec ou sans srifs', -1);
            ff_Script : affiche('scripte', -1);
            ff_Swiss : affiche('variable, sans srifs', -1);
            else affiche('erreur', tmPitchAndFamily);
          end; (* case *)

          case tmCharSet of
            ANSI_CharSet : affiche('ANSI', -1);
            Symbol_CharSet : affiche('symboles', -1);
            ShiftJis_CharSet : affiche('ShiftJis', -1);
            OEM_CharSet : affiche('OEM', -1);
          end; (* case *)

          affiche('surplomb', tmOverhang);
          affiche('aspect X', tmDigitizedAspectX);
          affiche('aspect Y', tmDigitizedAspectY);
        end; (* with l_metrique *)

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          (* -- la fentre par dfaut *)
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_Allure_Initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de recuperation et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
